/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.client.internal.ColumnHelper");

dojo.require("com.ibm.team.dashboard.web.client.internal.ViewletHelper");

(function() {

/*
 * Aliases
 */
var ViewletHelper = com.ibm.team.dashboard.web.client.internal.ViewletHelper;

/*
 * Models a column within a viewlet page.
 */
dojo.declare("com.ibm.team.dashboard.web.client.internal.ColumnHelper",
	null, {
	
	/*
	 * Constructs a new column.
	 */
	constructor: function(/* object */ rawHelper, /* DashboardItem */ item) {
		this._item = item;
		this._viewlets = new Array();
		if (rawHelper.viewlets) {
			for (var i=0;i<rawHelper.viewlets.length;i++) {
				this._viewlets.push(new ViewletHelper(rawHelper.viewlets[i], this._item));
			}
		}
	},

	/*
	 * Returns the containing dashboard item.
	 */
	/* DashboardItem */ getDashboardItem: function() {
		return this._item;
	},
	
	/*
	 * Returns an array of viewlets in the column.
	 */
	/* ViewletHelper[] */ getViewlets: function() {
		return this._viewlets;
	}
});

})();