/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor"); //$NON-NLS-1$

dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dojox.data.dom"); //$NON-NLS-1$
dojo.require("dojo.cookie"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.internal.Dialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.client.internal.AdminClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var PlatformUI = net.jazz.ajax.ui.PlatformUI;
var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;
var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var MANAGER = "com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
var USER_EDITOR = "com.ibm.team.repository.editUser"; //$NON-NLS-1$
var ARCHIVED_USER_EDITOR = "com.ibm.team.repository.editArchivedUser"; //$NON-NLS-1$
var PROJECT_AREA_EDITOR = "com.ibm.team.process.editProjectArea"; //$NON-NLS-1$
var TEAM_AREA_EDITOR = "com.ibm.team.process.editTeamArea"; //$NON-NLS-1$
var MSG_COOKIE_NAME = "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#saveMsg"; //$NON-NLS-1$
var TEAM_INVITATION_COOKIE_NAME= "com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor#teamInvite"; //$NON-NLS-1$
var KEY_RETURN = 13;
var KEY_ENTER = 14;
var MANAGE_ARCHIVED_LINK = "#action=com.ibm.team.process.manageArchivedProjectAreas"; //$NON-NLS-1$
var MANAGE_ACTIVE_LINK = "#action=com.ibm.team.process.manageProjectAreas"; //$NON-NLS-1$
var DEFAULT_DISPLAY_MAX = 5;
var SHOW_TEXT_LENGTH = 1024;
var MODE_PREVIEW = "Preview"; //$NON-NLS-1$
var MODE_EDIT = "Edit"; //$NON-NLS-1$
var EMPTY = ""; //$NON-NLS-1$
var BR = "br"; //$NON-NLS-1$
var DIV = "div"; //$NON-NLS-1$
var NONE = "none"; //$NON-NLS-1$
var BLOCK = "block"; //$NON-NLS-1$

dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.ProjectAreaEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
	
	templatePath: dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/templates/ProjectAreaEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
	
	constructor: function(args){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.ui.internal.admin.projects", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		this.isNew = args.itemId === "new"; //$NON-NLS-1$
		if (!this.isNew) {
			this.itemId = args.itemId;
		}
		this._projectAreaIconSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/projectAreaIcon.png"); //$NON-NLS-1$ //$NON-NLS-2$
	},
	
	postCreate: function () {
		this.showingAllMembers = false;
		this.showingAllAdmins = false;
		this.supportedLocales = [];
		this.displayableLocales = [];
		this.allProcessDefinitions = [];
		this.connectHandles = [];
		this.inputFields = [
			this.name,
			this.summary,
			this.description
		];
		this.connect(this.name, "onkeypress", function (e) { //$NON-NLS-1$
			if (e.keyCode === KEY_RETURN || e.keyCode === KEY_ENTER) {
				dojo.stopEvent(e);
				this.togglePrimaryField(MODE_PREVIEW);
			}
		});
		this.summary.viewElement = this.summaryView;
		this.summary.viewAllElement = this.summaryViewAll;
		this.summary.showAllLink = this.showAllSummaryLink;
		this.summary.showLessLink = this.showLessSummaryLink;
		this.summary.showingAll = false;
		this.description.viewElement = this.descriptionView;
		this.description.viewAllElement = this.descriptionViewAll;
		this.description.showAllLink = this.showAllDescriptionLink;
		this.description.showLessLink = this.showLessDescriptionLink;
		this.description.showingAll = false;
		this.editViewFields = [
			this.summary,
			this.description
		];
		this.connect(this.editViewTable,"onclick", function () { //$NON-NLS-1$
			this.toggleViewEditMode(MODE_EDIT);
		});
		if (!this.isNew) {
			this.connect(this.createChildButton,"onclick",function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				var name = this.name.savedValue;
				if (!this._handleNavigate()) {
					document.location.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=new&parentItemId=" + this.itemId + "&parentName=" + encodeURIComponent(name) + "&parentType=PROJECT"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				}
			});
			this.teamAreaHierarchy.style.display = EMPTY;
		}
		for (var i=0; i < this.inputFields.length; i++) {
			this.connect(this.inputFields[i],"onkeyup", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.inputFields[i],"onchange", "handleChange"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.connect(this.memberAddButton,"onclick", function (e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			if (this.allMembers == null) {
				this.allMembers = new Array();
			}
			this.addUserDialog(this.allMembers, "addNewMembers"); //$NON-NLS-1$
		});
		this.connect(this.adminAddButton,"onclick", function (e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			if (this.allAdmins == null) {
				this.allAdmins = new Array();
			}
			this.addUserDialog(this.allAdmins, "addNewAdmins"); //$NON-NLS-1$
		});
		this.connect(this.saveButton,"onclick", "handleSave"); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.toggleDescLink,"onclick", function (e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.toggleViewEditMode(e.target.innerHTML);
		});
		
		this.connect(this.previewName,"onmouseover", function (e) { //$NON-NLS-1$
			e.target.style.backgroundColor = "#FFFFCC"; //$NON-NLS-1$
		});
		this.connect(this.previewName,"onmouseout", function (e) { //$NON-NLS-1$
			e.target.style.backgroundColor = EMPTY;
		});
		this.connect(this.previewName,"onclick", function (e) { //$NON-NLS-1$
			this.togglePrimaryField(MODE_EDIT);
		});
		this.connect(this.name, "onblur", function (e) { //$NON-NLS-1$
			this.togglePrimaryField(MODE_PREVIEW);
		});
		this.connect(this.showAllSummaryLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.summary.showingAll = true;
			this.summary.viewAllElement.style.display = "inline"; //$NON-NLS-1$
			this.summary.showAllLink.style.display = NONE;
			this.summary.showLessLink.style.display = BLOCK;
		});
		this.connect(this.showLessSummaryLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.summary.showingAll = false;
			this.summary.viewAllElement.style.display = NONE;
			this.summary.showAllLink.style.display = BLOCK;
			this.summary.showLessLink.style.display = NONE;
		});
		this.connect(this.showAllDescriptionLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.description.showingAll = true;
			this.description.viewAllElement.style.display = "inline"; //$NON-NLS-1$
			this.description.showAllLink.style.display = NONE;
			this.description.showLessLink.style.display = BLOCK;
		});
		this.connect(this.showLessDescriptionLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.description.showingAll = false;
			this.description.viewAllElement.style.display = NONE;
			this.description.showAllLink.style.display = BLOCK;
			this.description.showLessLink.style.display = NONE;
		});
		this.connect(this.showAllMembersLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.showingAllMembers = true;
			this.showAllMembersLink.style.display = NONE;
			this.showFewerMembersLink.style.display = BLOCK;
			for (var i=0; i < this.memberArea.rows.length; i++) {
				this.memberArea.rows[i].style.display = EMPTY;
			}
		});
		this.connect(this.showFewerMembersLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.showingAllMembers = false;
			this.showAllMembersLink.style.display = BLOCK;
			this.showFewerMembersLink.style.display = NONE;
			for (var i=DEFAULT_DISPLAY_MAX; i < this.memberArea.rows.length; i++) {
				this.memberArea.rows[i].style.display = NONE;
			}
		});
		this.connect(this.showAllAdminsLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.showingAllAdmins = true;
			this.showAllAdminsLink.style.display = NONE;
			this.showFewerAdminsLink.style.display = BLOCK;
			for (var i=0; i < this.adminArea.rows.length; i++) {
				this.adminArea.rows[i].style.display = EMPTY;
			}
		});
		this.connect(this.showFewerAdminsLink, "onclick", function(e) { //$NON-NLS-1$
			dojo.stopEvent(e);
			this.showingAllAdmins = false;
			this.showAllAdminsLink.style.display = BLOCK;
			this.showFewerAdminsLink.style.display = NONE;
			for (var i=DEFAULT_DISPLAY_MAX; i < this.adminArea.rows.length; i++) {
				this.adminArea.rows[i].style.display = NONE;
			}
		});
		this.refresh();
	},
	
	addUserDialog: function (filterUsers, callbackFunction) {
		var userFilter = new Array();
		for (var i=0; i < filterUsers.length; i++) {
			userFilter.push({'itemId': filterUsers[i].itemId}); //$NON-NLS-1$
		}
		var userPicker = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({'disableUsers': userFilter}); //$NON-NLS-1$
		this.connect(userPicker,"onAdd",callbackFunction); //$NON-NLS-1$
	},
	
	refresh: function () {
		if (!this.navigateAwayHandle) {
			this.navigateAwayHandle = PlatformUI.getWorkbench().registerBodyClickHandler(dojo.hitch(this, this._handleNavigate), /*priority*/ 10000);
			this.onBeforeUnloadHandle = PlatformUI.getWorkbench().registerOnBeforeUnloadHandler(dojo.hitch(this, this.navigateAwayEvent), /*priority*/ 10000);
		}
		this.clearState();
		dojox.data.dom.removeChildren(this.processDescription);
		this.processDescription.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_34));
		if (this.isNew) {
			this.toggleViewEditMode(MODE_EDIT);
			this.name.value = this.messages.ProjectAreaEditor_1;
			this.togglePrimaryField(MODE_EDIT);
			this.populateMembers(new Array());
			this.populateAdmins(new Array());
			var srh = new ServiceResponseHandler(this, "populateProcessSelector", "handleFetchProcessError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getPredefinedProcesses(srh);
			setTimeout(dojo.hitch(this.name,"select"), 250); //$NON-NLS-1$
		}
		else {
			dojox.data.dom.removeChildren(this.memberArea);			
			dojox.data.dom.removeChildren(this.adminArea);
			
			var srh = new ServiceResponseHandler(this, "populateProjectAreaData", "handleProjectAreaFetchError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getProjectAreaByUUID({uuid: this.itemId}, srh);
			
			this.teamAreaHierarchyContent.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_35));
			
			var srh = new ServiceResponseHandler(this, "populateTeamAreaHierarchy", "handleTeamAreaHierarchyFetchError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.getProjectHierarchy({uuid: this.itemId}, srh);
		}
		this.checkForSuccessMsg();
	},
	
	_handleNavigate: function(urlObj) {
		if (this.changesPending()) {
			if (confirm(this.messages.ProjectAreaEditor_2)) {
				PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
				this.navigateAwayHandle = null;
				PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
				this.onBeforeUnloadHandle = null;
				return false;
			}
			else {
				return true;
			}
		}
		return false;
	},
	
	navigateAwayEvent: function() {
		return this.changesPending() ? this.messages.ProjectAreaEditor_3 : false;
	},
	
	checkForSuccessMsg: function () {
		var msgCookie = dojo.cookie(MSG_COOKIE_NAME);
		if (msgCookie) {
			this.displaySuccessMessage(msgCookie, true);
			var now = new Date();
			now.setTime(now.getTime() - 1);
			dojo.cookie(MSG_COOKIE_NAME,EMPTY,{expires: now});
		}
	},
	
	checkForTeamInvitation: function () {
		var inviteCookie = dojo.cookie(TEAM_INVITATION_COOKIE_NAME);
		if (inviteCookie) {
			this.chooseTeamInvitees(dojo.fromJson(inviteCookie));
			
			var now = new Date();
			now.setTime(now.getTime() - 1);
			dojo.cookie(TEAM_INVITATION_COOKIE_NAME,EMPTY,{expires: now});
		}
	},
	
	clearState: function () {
		this.setDirty(false);
		this.pendingMemberChanges = {};
		this.pendingAdminChanges = {};
		this.allMembers = [];
		this.allAdmins = [];
		dojox.data.dom.removeChildren(this.messageBox);
		dojox.data.dom.removeChildren(this.longMessageBox);
		dojox.data.dom.removeChildren(this.teamAreaHierarchyContent);
		this.messageBox.className = EMPTY;
		this.longMessageBox.className = EMPTY;
		this.name.value = EMPTY;
		this.summary.value = EMPTY;
		this.description.value = EMPTY;
		dojox.data.dom.removeChildren(this.memberArea);
		dojox.data.dom.removeChildren(this.adminArea);
		for (var i=0; i < this.inputFields.length; i++) {
			this.inputFields[i].changePending = false;
		}
	},
	
	handleFetchProcessError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_4));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	handleDeployTemplateError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_5));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	handleProjectAreaFetchError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_6));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	togglePrimaryField: function (mode) {
		if (mode === MODE_PREVIEW) {
			this.name.style.display = NONE;
			dojox.data.dom.removeChildren(this.previewName);
			this.previewName.appendChild(document.createTextNode(this.name.value || this.messages.ProjectAreaEditor_7));
			this.previewName.style.display = EMPTY;
		}
		else if (mode === MODE_EDIT) {
			this.previewName.style.display = NONE;
			this.name.style.display = EMPTY;
			this.name.focus();
			this.name.select();
			this.displayMessage(EMPTY,EMPTY);
		}
	},
	
	toggleViewEditMode: function (mode) {
		if (mode === MODE_PREVIEW) {
			dojo.forEach(this.editViewFields, function (field) {
				field.style.display = NONE;
				dojox.data.dom.removeChildren(field.viewElement);
				var previewString = field.value.substring(0,SHOW_TEXT_LENGTH);
				var hiddenString = field.value.substring(SHOW_TEXT_LENGTH);
				if (field.value.length > SHOW_TEXT_LENGTH) {
					var spaceIndex = hiddenString.indexOf(" "); //$NON-NLS-1$
					var newlineIndex = hiddenString.indexOf("\n"); //$NON-NLS-1$
					// if there is no good point to break the string in hiddenString, just show the whole thing
					if (spaceIndex === -1 && newlineIndex === -1) {
						previewString += hiddenString;
						hiddenString = EMPTY;
					}
					else if (newlineIndex === -1 || (spaceIndex !== -1 && spaceIndex < newlineIndex)) {
						previewString += hiddenString.substring(0, spaceIndex);
						hiddenString = hiddenString.substring(spaceIndex);
					}
					else if (spaceIndex === -1 || (newlineIndex !== -1 && newlineIndex < spaceIndex)) {
						previewString += hiddenString.substring(0, newlineIndex);
						hiddenString = hiddenString.substring(newlineIndex);
					}
				}
				var strings = previewString.split(/\n/);
				for (var i=0; i < strings.length; i++) {
					if (i > 0) {
						field.viewElement.appendChild(document.createElement(BR));
					}
					if (strings[i].length > 0) {
						field.viewElement.appendChild(document.createTextNode(strings[i]));
					}
				}
				field.viewElement.style.display = EMPTY;
				dojox.data.dom.removeChildren(field.viewAllElement);
				if (hiddenString != null && hiddenString !== EMPTY) {
					strings = hiddenString.split(/\n/);
					for (var i=0; i < strings.length; i++) {
						if (i > 0) {
							field.viewAllElement.appendChild(document.createElement(BR));
						}
						if (strings[i].length > 0) {
							field.viewAllElement.appendChild(document.createTextNode(strings[i]));
						}
					}
					if (field.showingAll) {
						field.viewAllElement.style.display = "inline"; //$NON-NLS-1$
						field.showLessLink.style.display = BLOCK;
						field.showAllLink.style.display = NONE;
					}
					else {
						field.viewAllElement.style.display = NONE;
						field.showLessLink.style.display = NONE;
						field.showAllLink.style.display = BLOCK;
					}
				}
			});
			dojox.data.dom.removeChildren(this.toggleDescLink);
			this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_8));
		}
		else if (mode === MODE_EDIT) {
			dojox.data.dom.removeChildren(this.toggleDescLink);
			this.toggleDescLink.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_9));
			dojo.forEach(this.editViewFields, function (field) {
				field.viewElement.style.display = NONE;
				field.viewAllElement.style.display = NONE;
				field.style.display = EMPTY;
				field.showAllLink.style.display = NONE;
				field.showLessLink.style.display = NONE;
			});
		}
	},
	
	populateProjectAreaData: function (data) {
		this.showBreadcrumbs(data.archived);
		if (!data.archived) {
			this.createChildButton.style.display = EMPTY;
		}
		this.name.value = data.name;
		this.name.savedValue = data.name;
		this.processLocale = data.locale;
		this.togglePrimaryField(MODE_PREVIEW);
		this.summary.value = data.summary;
		this.summary.savedValue = data.summary;
		this.description.value = data.description;
		this.description.savedValue = data.description;
		if (data.description) {
			this.toggleViewEditMode(MODE_PREVIEW);
		}
		else {
			this.toggleViewEditMode(MODE_EDIT);
		}
		this.populateProcessDescription(data.processDTO);
		this.allProcessRoles = data.processDTO.roles;
		this.allMembers = data.members;
		this.allAdmins = data.admins;
		this.populateMembers(this.allMembers);
		this.populateAdmins(this.allAdmins);
		this.checkForTeamInvitation();
	},
	
	showBreadcrumbs: function (isArchived) {
		dojox.data.dom.removeChildren(this.breadcrumbs);
		var link = document.createElement("a"); //$NON-NLS-1$
		link.href = isArchived ? MANAGE_ARCHIVED_LINK : MANAGE_ACTIVE_LINK;
		link.appendChild(document.createTextNode(isArchived ? this.messages.ProjectAreaEditor_10 : this.messages.ProjectAreaEditor_11));
		this.breadcrumbs.appendChild(link);
		var span = document.createElement("span"); //$NON-NLS-1$
		span.appendChild(document.createTextNode(">")); //$NON-NLS-1$
		this.breadcrumbs.appendChild(span);
	},
	
	populateTeamAreaHierarchy: function (data) {
		dojox.data.dom.removeChildren(this.teamAreaHierarchyContent);
		var div = document.createElement(DIV);
		div.className = "hierarchyElement selected"; //$NON-NLS-1$
		div.appendChild(document.createTextNode(data.name));
		this.teamAreaHierarchyContent.appendChild(div);
		if (data.children != null) {
			this.displayProcessChildren(data.children, 1);
		}
	},
	
	displayProcessChildren: function (children, indent) {
		children = children.sort(function (a,b) {
			return a.name > b.name ? 1 : a.name < b.name ? -1 : 0;
		});
		for (var i=0; i < children.length; i++) {
			var div = document.createElement(DIV);
			div.className = "hierarchyElement"; //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.tabIndex = 3;
			link.href = "#action=" + TEAM_AREA_EDITOR + "&itemId=" + children[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
			link.appendChild(document.createTextNode(children[i].name));
			div.appendChild(link);
			div.style.paddingLeft = (indent * 15) + "px"; //$NON-NLS-1$
			this.teamAreaHierarchyContent.appendChild(div);
			if (children[i].children != null) {
				this.displayProcessChildren(children[i].children, indent + 1);
			}
		}
	},
	
	handleTeamAreaHierarchyFetchError: function (err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_12));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	displaySelectedProcessInformation: function() {
		dojox.data.dom.removeChildren(this.selectedProcessDescription);
		
		var translatedSummary = this.processSelector.options[this.processSelector.selectedIndex].translatedSummary;
		this.selectedProcessDescription.appendChild(document.createTextNode(translatedSummary));
		
		dojox.data.dom.removeChildren(this.selectedProcessLocale);
		var localeString = this.processSelector.options[this.processSelector.selectedIndex].displayableLocale;
		if (!localeString || localeString.length == 0) {
			localeString = this.messages.ProjectAreaEditor_46;
		}
		this.selectedProcessLocale.appendChild(document.createTextNode(localeString));
	},
	
	getTranslatedProcessDefinitionName: function(definition) {
		var translatedName;
		
		// if locale filtering is on, use the currently selected locale
		// if locale filtering is off, see if the definition entry has an
		// associated locale
		var locale;
		if (this.localeFilterToggle.checked) {
			locale = this.localeSelector.options[this.localeSelector.selectedIndex].value;
		} else {
			locale = definition.locale;
		}
		
		if (locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
			if (dojo.indexOf(definition.supportedLocales, locale) != -1) {
				translatedName = definition.translatedNames[dojo.indexOf(definition.supportedLocales, locale)];
			}
		}
    				
		// try the default name
		if (!translatedName) {
			translatedName = definition.defaultName;
		}
		
		// default to the untranslated value
		if (!translatedName) {
			translatedName = definition.name;
		}
		
		return translatedName;
	},
	
	getTranslatedProcessDefinitionSummary: function(definition) {
		var translatedSummary;
		
		// if locale filtering is on, use the currently selected locale
		// if locale filtering is off, see if the definition entry has an
		// associated locale
		var locale;
		if (this.localeFilterToggle.checked) {
			locale = this.localeSelector.options[this.localeSelector.selectedIndex].value;
		} else {
			locale = definition.locale;
		}
		
		if (locale && definition.supportedLocales && definition.supportedLocales.length > 0) {
			if (dojo.indexOf(definition.supportedLocales, locale) != -1) {
				translatedSummary = definition.translatedSummaries[dojo.indexOf(definition.supportedLocales, locale)];
			}
		}
    				
		// try the default summary
		if (!translatedSummary) {
			translatedSummary = definition.defaultSummary;
		}
		
		// default to the untranslated value
		if (!translatedSummary) {
			translatedSummary = definition.summary;
		}
		
		return translatedSummary;
	},
	
	/**
	 * Check the list of supportedLocales for the closest to the current
	 * client locale. Look for an exact match first, then check for a supported 
	 * locale with  the same language code as the current client locale.
	 * 
	 * @param supportedLocales
	 *     An array of locale strings like "zh", "en-us", etc.
	 *     
	 * @return the index in the specified list of the locale that was found
	 *     or -1 if no match was found
	 */
	getSupportedClientLocale: function(supportedLocales) {
		var clientLocale = djConfig.locale;
		
		if (clientLocale) {
			// if the client locale has a direct match, return it
			if (dojo.indexOf(supportedLocales, clientLocale) != -1) {
				return dojo.indexOf(supportedLocales, clientLocale);
			}
			
			// we don't support the client locale directly, so see if we
			// support a locale with the same language code
			if (clientLocale.length > 2) {
				clientLocale = clientLocale.substring(0, 2);
			}
				
			var supportedLocale = -1;
			for (var i=0; i<supportedLocales.length; i++) {
				if (supportedLocales[i] === clientLocale) {
					return i;
				}
				if (supportedLocales[i].indexOf(clientLocale) == 0) {
					supportedLocale = i;
				}
			}
			return supportedLocale;
		}
	},
	
	populateFilteredProcesses: function(e) {
		this.localeSelector.disabled = this.localeFilterToggle.disabled || !this.localeFilterToggle.checked;
		
		var definitionsToShow;
		
		if (this.localeFilterToggle.checked) {
			var locale = this.localeSelector.options[this.localeSelector.selectedIndex].value;
    		definitionsToShow = dojo.filter(this.allProcessDefinitions, function(definition) {
    			return locale === definition.locale;
    		});
		} else {
			definitionsToShow = this.allProcessDefinitions;
		}
		
		this.processSelector.options.length = 0;
		
		var newOptions = dojo.map(definitionsToShow, function(definition) {
			var option = new Option(this.getTranslatedProcessDefinitionName(definition), definition.itemId);
			option.translatedSummary = this.getTranslatedProcessDefinitionSummary(definition);
			option.locale = definition.locale;
			option.displayableLocale = definition.displayableLocale;
			return option;
		}, this);
		
		dojo.forEach(newOptions, function(option) {
			if (dojo.isIE) {
				this.processSelector.options[this.processSelector.options.length] = option;
			}
			else {
				this.processSelector.appendChild(option);
			}
		}, this);
		
		this.processSelector.selectedIndex = 0;
		this.displaySelectedProcessInformation();
	},
	
	populateProcessSelector: function (data) {
		if (data != null && data.length > 0) {
    		this.processDescription.style.display = NONE;
    		this.processSelection.style.display = BLOCK;
    		
    		this.supportedLocales.length = 0;
    		this.displayableLocales.length = 0;
			this.allProcessDefinitions.length = 0;
    
            // populate the 'allProcessDefinitions' list
    		dojo.forEach(data, function(processDef) {
    			if (processDef.supportedLocales && processDef.supportedLocales.length > 0) {
    				for (var i=0; i<processDef.supportedLocales.length; i++) {
    					var localeDefEntry = dojo.clone(processDef);
    					localeDefEntry.locale = processDef.supportedLocales[i];
    					localeDefEntry.displayableLocale = processDef.displayableLocales[i];
    					this.allProcessDefinitions.push(localeDefEntry);
    				}
    			} else {
    				this.allProcessDefinitions.push(processDef);
    			}
    		}, this);
		
			// populate the list of supported locales
			this.localeSelector.options.length = 0;
			dojo.forEach(data, function(processDefinitionDTO) {
				if (processDefinitionDTO.supportedLocales) {
					for (var i = 0; i < processDefinitionDTO.supportedLocales.length; i++) {
						var locale = processDefinitionDTO.supportedLocales[i];
						if (dojo.indexOf(this.supportedLocales, locale) == -1) {
							this.supportedLocales.push(locale);
							this.displayableLocales.push(processDefinitionDTO.displayableLocales[i]);
							
							// add the supported locale to locale selector
                			var option = new Option(processDefinitionDTO.displayableLocales[i], locale);
                			if (dojo.isIE) {
                				this.localeSelector.options[this.localeSelector.options.length] = option;
                			}
                			else {
                				this.localeSelector.appendChild(option);
                			}
						}
					}
				}
			}, this);
			
    		this.connectHandles.push(dojo.connect(this.localeFilterToggle,"onclick",this,this.populateFilteredProcesses)); //$NON-NLS-1$
    		this.connectHandles.push(dojo.connect(this.localeSelector,"onchange",this,this.populateFilteredProcesses)); //$NON-NLS-1$
    		this.connectHandles.push(dojo.connect(this.processSelector,"onchange",this,this.displaySelectedProcessInformation)); //$NON-NLS-1$
    		
			if (this.supportedLocales.length > 0) {
    			// attempt to select the supported locale closest to the current client locale
    			var localeIndex = this.getSupportedClientLocale(this.supportedLocales);
				
    			if (localeIndex == -1) {
            		this.localeFilterToggle.checked = false;
    				localeIndex = 0;
    			} else {
            		this.localeFilterToggle.checked = true;
    			}
				
    			this.localeSelector.selectedIndex = localeIndex;
			} else {
				this.localeFilterToggle.disabled = true;
				this.localeFilterText.style.color = "#808080"; //$NON-NLS-1$
				this.localeSelector.disabled = true;
				
				// work around lack of min-width support
        		if (dojo.isIE) {
					this.localeSelector.style.width = "10em"; //$NON-NLS-1$
				}
			}
			
    		this.populateFilteredProcesses();
     		this.setDirty(true);

		}
		else {
			// no process definitions, so add the "deploy definitions" controls
    		dojox.data.dom.removeChildren(this.processDescription);
    		this.processDescription.style.display = BLOCK;
    		this.processSelection.style.display = NONE;
			
			this.processDescription.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_13));
			this.processDescription.appendChild(document.createElement(BR));
			this.processDescription.appendChild(document.createElement(BR));
			var requiredFlag = document.createElement("span"); //$NON-NLS-1$
			requiredFlag.className = "requiredFlag"; //$NON-NLS-1$
			requiredFlag.appendChild(document.createTextNode("* ")); //$NON-NLS-1$
			this.processDescription.appendChild(requiredFlag);
			var link = document.createElement("a"); //$NON-NLS-1$
			link.tabIndex = 2;
			link.href = "#"; //$NON-NLS-1$
			link.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_14));
			this.connect(link,"onclick","deployPredefinedProcessDefinitions"); //$NON-NLS-1$ //$NON-NLS-2$
			this.processDescription.appendChild(link);
		}
	},
	
	deployPredefinedProcessDefinitions: function (e) {
		dojo.stopEvent(e);
		var srh = new ServiceResponseHandler(this, "handleDeployTemplateSuccess", "handleDeployTemplateError"); //$NON-NLS-1$ //$NON-NLS-2$
		this.displayPendingMessage(this.messages.ProjectAreaEditor_15);
		ProcessClient.deployPredefinedProcessDefinitions(srh);
	},
	
	handleDeployTemplateSuccess: function () {
		this.setDirty(this.changesPending());
		this.displaySuccessMessage(this.messages.ProjectAreaEditor_16);
		this.refreshProcessDefs();
	},
	
	refreshProcessDefs: function () {
		dojox.data.dom.removeChildren(this.processDescription);
		this.processDescription.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_17));
		var srh = new ServiceResponseHandler(this, "populateProcessSelector", "handleFetchProcessError"); //$NON-NLS-1$ //$NON-NLS-2$
		ProcessClient.getPredefinedProcesses(srh);
	},
	
	populateProcessDescription: function (data) {
		dojox.data.dom.removeChildren(this.processDescription);
		this.processDescription.style.display = BLOCK;
		this.processSelection.style.display = NONE;
		
		var empty = true;
		if (data.name) {
			empty = false;
			var div = document.createElement(DIV);
			div.style.marginBottom = "1em"; //$NON-NLS-1$
			div.appendChild(document.createTextNode(data.name));
			var hr = document.createElement("hr"); //$NON-NLS-1$
			hr.style.border = NONE;
			hr.style.borderTop = "1px solid #EEEEEE"; //$NON-NLS-1$
			div.appendChild(hr);
			this.processDescription.appendChild(div);
		}
		if (data.details) {
			empty = false;
			var div = document.createElement(DIV);
			div.appendChild(document.createTextNode(data.details));
			this.processDescription.appendChild(div);
		}
		else if (data.summary) {
			empty = false;
			var div = document.createElement(DIV);
			div.appendChild(document.createTextNode(data.summary));
			this.processDescription.appendChild(div);
		}
		if (empty) {
			desc = "No process description found."; //$NON-NLS-1$
			this.processDescription.appendChild(document.createTextNode(desc));
		}
	},
	
	populateMembers: function (members) {
		this.populateUsers(members, this.memberHeader, this.memberArea, !this.isNew, this.showingAllMembers, "memberRemoveHandler", "processRoleHandler", "teamInviteHandler"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ 
		if (members != null && members.length > DEFAULT_DISPLAY_MAX) {
			if (this.showingAllMembers) {
				this.showFewerMembersLink.style.display = BLOCK;
				this.showAllMembersLink.style.display = NONE;
			}
			else {
				this.showFewerMembersLink.style.display = NONE;
				this.showAllMembersLink.style.display = BLOCK;
			}
		}
		else {
			this.showFewerMembersLink.style.display = NONE;
			this.showAllMembersLink.style.display = NONE;
		}
	},
	
	populateAdmins: function (admins) {
		this.populateUsers(admins, this.adminHeader, this.adminArea, false, this.showingAllAdmins, "adminRemoveHandler"); //$NON-NLS-1$
		if (admins != null && admins.length > DEFAULT_DISPLAY_MAX) {
			if (this.showingAllAdmins) {
				this.showFewerAdminsLink.style.display = BLOCK;
				this.showAllAdminsLink.style.display = NONE;
			}
			else {
				this.showFewerAdminsLink.style.display = NONE;
				this.showAllAdminsLink.style.display = BLOCK;
			}
		}
		else {
			this.showFewerAdminsLink.style.display = NONE;
			this.showAllAdminsLink.style.display = NONE;
		}
	},
	
	populateUsers: function (users, header, userArea, isNotNew, showAll, removeHandler, processRoleHandler, teamInviteHandler) {
		dojox.data.dom.removeChildren(header);
		var tr = document.createElement("tr"); //$NON-NLS-1$
		tr.className = "headerLineRow"; //$NON-NLS-1$
		var th = document.createElement("th"); //$NON-NLS-1$
		if (dojo.isIE) {
			th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
		}
		th.className = "memberName"; //$NON-NLS-1$
		tr.appendChild(th);
		if (isNotNew) {
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "memberRoles"; //$NON-NLS-1$
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			tr.appendChild(th);
		}
		else {
			th = document.createElement("th"); //$NON-NLS-1$
			th.className = "memberMail"; //$NON-NLS-1$
			if (dojo.isIE) {
				th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			}
			tr.appendChild(th);
		}
		th = document.createElement("th"); //$NON-NLS-1$
		th.className = "iconNode"; //$NON-NLS-1$
		if (dojo.isIE) {
			th.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
		}
		tr.appendChild(th);
		header.appendChild(tr);
		tr = document.createElement("tr"); //$NON-NLS-1$
		th = document.createElement("th"); //$NON-NLS-1$
		th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_18));
		th.className = "memberName"; //$NON-NLS-1$
		tr.appendChild(th);
		if (isNotNew) {
			th = document.createElement("th"); //$NON-NLS-1$
			th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_19));
			th.className = "memberRoles"; //$NON-NLS-1$
			tr.appendChild(th);
		}
		else {
			th = document.createElement("th"); //$NON-NLS-1$
			th.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_20));
			th.className = "memberMail"; //$NON-NLS-1$
			tr.appendChild(th);
		}
		th = document.createElement("th"); //$NON-NLS-1$
		th.className = "iconNode"; //$NON-NLS-1$
		tr.appendChild(th);
		
		header.appendChild(tr);
		dojox.data.dom.removeChildren(userArea);
		if (users != null && users.length > 0) {
			for (var i=0; i < users.length; i++) {
				var tr = document.createElement("tr"); //$NON-NLS-1$
				tr.userObj = users[i];
				var td = document.createElement("td"); //$NON-NLS-1$
				td.className = "memberName"; //$NON-NLS-1$
				var link = document.createElement("a"); //$NON-NLS-1$
				if (users[i].archived) {
					link.href = "#action=" + ARCHIVED_USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
				}
				else {
					link.href = "#action=" + USER_EDITOR + "&itemId=" + users[i].itemId; //$NON-NLS-1$ //$NON-NLS-2$
				}
				link.appendChild(document.createTextNode(users[i].name));
				td.appendChild(link);
				tr.appendChild(td);
				if (isNotNew) {
					td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberRoles"; //$NON-NLS-1$
					var roleStr = EMPTY;
					if (users[i].processRoles != null) {
						users[i].savedProcessRoles = users[i].processRoles;
						var roleIds = new Array();
						for (var j=0; j < users[i].processRoles.length; j++) {
							// hide the default role from the display
							if (users[i].processRoles[j].id != "default") { //$NON-NLS-1$
								roleIds.push(users[i].processRoles[j].id);
							}
						}
						roleStr = roleIds.join(", "); //$NON-NLS-1$
					}
					if (dojo.isIE && roleStr === EMPTY) {
						roleStr = " "; //$NON-NLS-1$
					}
					td.appendChild(document.createTextNode(roleStr));
					tr.roleDisplay = td;
				}
				else {
					td = document.createElement("td"); //$NON-NLS-1$
					td.className = "memberMail"; //$NON-NLS-1$
					if (users[i].emailAddress) {
						var link = document.createElement("a"); //$NON-NLS-1$
						link.href = "mailto:" + users[i].emailAddress; //$NON-NLS-1$
						link.appendChild(document.createTextNode(users[i].emailAddress));
						td.appendChild(link);
					}
					else if (dojo.isIE) {
						td.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
					}
					tr.mailDisplay = td;
				}
				tr.appendChild(td);
				td = document.createElement("td"); //$NON-NLS-1$
				td.className = "iconNode"; //$NON-NLS-1$
				if (isNotNew && teamInviteHandler != null) {
					var teamInviteIcon = document.createElement("img"); //$NON-NLS-1$
					teamInviteIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					teamInviteIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					teamInviteIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/team-invite-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					this.connect(teamInviteIcon, "onclick", teamInviteHandler); //$NON-NLS-1$
					this.connectHandles.push(dojo.connect(teamInviteIcon, "onmouseover", teamInviteIcon, function (e) { //$NON-NLS-1$
						this.src = this.hoverSrc;
					}));
					this.connectHandles.push(dojo.connect(teamInviteIcon, "onmouseout", teamInviteIcon, function (e) { //$NON-NLS-1$
						this.src = this.nohoverSrc;
					}));
					teamInviteIcon.title = this.messages.ProjectAreaEditor_40;
					td.appendChild(teamInviteIcon);
				}
				if (isNotNew) {
					var processRolesIcon = document.createElement("img"); //$NON-NLS-1$
					processRolesIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					processRolesIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					processRolesIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/process-roles-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
					this.connect(processRolesIcon, "onclick", processRoleHandler); //$NON-NLS-1$
					this.connectHandles.push(dojo.connect(processRolesIcon, "onmouseover", processRolesIcon, function (e) { //$NON-NLS-1$
						this.src = this.hoverSrc;
					}));
					this.connectHandles.push(dojo.connect(processRolesIcon, "onmouseout", processRolesIcon, function (e) { //$NON-NLS-1$
						this.src = this.nohoverSrc;
					}));
					processRolesIcon.title = this.messages.ProjectAreaEditor_21;
					td.appendChild(processRolesIcon);
				}
				var removeIcon = document.createElement("img"); //$NON-NLS-1$
				removeIcon.src = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.nohoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.hoverSrc = dojo.moduleUrl("com.ibm.team.process.web", "ui/internal/admin/projects/images/remove-hov.gif"); //$NON-NLS-1$ //$NON-NLS-2$
				removeIcon.title = this.messages.ProjectAreaEditor_22;
				this.connect(removeIcon,"onclick",removeHandler); //$NON-NLS-1$
				this.connectHandles.push(dojo.connect(removeIcon, "onmouseover", removeIcon, function (e) { //$NON-NLS-1$
					this.src = this.hoverSrc;
				}));
				this.connectHandles.push(dojo.connect(removeIcon, "onmouseout", removeIcon, function (e) { //$NON-NLS-1$
					this.src = this.nohoverSrc;
				}));
				td.appendChild(removeIcon);
				tr.appendChild(td);
				this.connectHandles.push(dojo.connect(tr, "onmouseover", tr, function (e) { //$NON-NLS-1$
					dojo.toggleClass(this, "highlighted", true); //$NON-NLS-1$
				}));
				this.connectHandles.push(dojo.connect(tr, "onmouseout", function (e) { //$NON-NLS-1$
					dojo.toggleClass(this, "highlighted", false); //$NON-NLS-1$
				}));
				if (!showAll && i >= DEFAULT_DISPLAY_MAX) {
					tr.style.display = NONE;
				}
				userArea.appendChild(tr);
			}
		}
	},
	
	memberRemoveHandler: function (e) {
		if (this.pendingMemberChanges["remove"] == null) { //$NON-NLS-1$
			this.pendingMemberChanges["remove"] = new Array(); //$NON-NLS-1$
		}
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		var itemId = selectedUser.itemId;
		
		this.pendingMemberChanges.remove.push(itemId);
		for (var j=0; j < this.allMembers.length; j++) {
			if (itemId === this.allMembers[j].itemId) {
				this.allMembers.splice(j,1);
				break;
			}
		}
		if (this.pendingMemberChanges.add != null) {
			for (var j=0; j < this.pendingMemberChanges.remove.length; j++) {
				if (this.pendingMemberChanges.add[j] == itemId) {
					this.pendingMemberChanges.add.splice(j,1);
					break;
				}
			}
		}
		this.setDirty(true);
		this.populateMembers(this.allMembers);
	},
	
	processRoleHandler: function (e) {
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		this.processRoleRow = rowNode;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var roleObj = new Object();
		roleObj.allRoles = this.allProcessRoles;
		roleObj.member = selectedUser;
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
		if (dialogWidget == null) {
			var processRoleDialog = new com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog(roleObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog", //$NON-NLS-1$
				primaryTitle: this.messages.ProjectAreaEditor_23,
				contentNode: processRoleDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				execute: function(selectedRoles) {
					var roleIds = new Array();
					for (var i=0; i < selectedRoles.length; i++) {
						// hide the default role from the display
						if (selectedRoles[i].id != "default") { //$NON-NLS-1$
							roleIds.push(selectedRoles[i].id);
						}
					}
					var roleString = roleIds.join(", "); //$NON-NLS-1$
					var selectedRow = this.targetObj.processRoleRow;
					dojox.data.dom.removeChildren(selectedRow.roleDisplay);
					selectedRow.roleDisplay.appendChild(document.createTextNode(roleString));
					selectedRow.userObj.processRoles = selectedRoles;
					var roleChanged = false;
					if (selectedRoles.length == selectedRow.userObj.savedProcessRoles.length) {
						for (var j=0; j < selectedRoles.length; j++) {
							if (selectedRoles[j].id != selectedRow.userObj.savedProcessRoles[j].id) {
								roleChanged = true;
								break;
							}
						}
					}
					else {
						roleChanged = true;
					}
					if (roleChanged) {
						var roleArray = new Array();
						for (var j=0; j < selectedRow.userObj.processRoles.length; j++) {
							roleArray.push(selectedRow.userObj.processRoles[j].id);
						}
						if (this.targetObj.pendingMemberChanges["roles"] == null) { //$NON-NLS-1$
							this.targetObj.pendingMemberChanges["roles"] = new Object(); //$NON-NLS-1$
						}
						this.targetObj.pendingMemberChanges["roles"][selectedRow.userObj.itemId] = roleArray; //$NON-NLS-1$
					}
					else {
						if (this.targetObj.pendingMemberChanges["roles"] != null) { //$NON-NLS-1$
							delete this.targetObj.pendingMemberChanges["roles"][selectedRow.userObj.itemId]; //$NON-NLS-1$
							var roleChanges = false;
							for (var j in this.targetObj.pendingMemberChanges["roles"]) { //$NON-NLS-1$
								roleChanges = true;
								break;
							}
							if (!roleChanges) {
								delete this.targetObj.pendingMemberChanges["roles"]; //$NON-NLS-1$
							}
						}
					}
					if (this.targetObj.changesPending()) {
						this.targetObj.saveButton.disabled = false;
					}
					else {
						this.targetObj.saveButton.disabled = true;
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.processRoleDialogObj = processRoleDialog;
			this.connectHandles.push(dojo.connect(processRoleDialog.cancelButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(processRoleDialog.finishButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				this.execute(this.processRoleDialogObj.getChosenRoles());
				this.close();
			}));
		}
		else {
			dialogWidget.processRoleDialogObj.repopulate(roleObj);
			dialogWidget.targetObj = this;
		}
	},
	
	teamInviteHandler: function (e) {
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		this.customizeAndSendTeamInvitation([ rowNode.userObj.itemId ], rowNode.userObj, false);
	},
		
    createInvitationPropertiesString: function(user, repoLink) {
		return dojo.string.substitute("teamRepository=${0}\nuserId=${1}\nuserName=${2}\nprojectAreaName=${3}", [ repoLink, user.userId, user.name, this.name.value ]); //$NON-NLS-1$
	},
		
    customizeAndSendTeamInvitation: function(invitees, singleUser, showLink) {
		var emailObj = new Object();
		emailObj.subject = dojo.string.substitute(this.messages.ProjectAreaEditor_39, [ this.name.value ]);
		
		var host = document.location.protocol + "//" + document.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
		var link = dojo.string.substitute("${0}/web/projects/${1}", [ host, this.name.value ]); //$NON-NLS-1$
		link = encodeURI(link);
		emailObj.message = dojo.string.substitute(this.messages.ProjectAreaEditor_38, [ this.name.value, link ]);
		
		if (invitees.length == 1) {
    		emailObj.description = dojo.string.substitute(this.messages.ProjectAreaEditor_36, [ singleUser.name ]);
			emailObj.singleUserObj = singleUser;
			emailObj.properties = this.createInvitationPropertiesString(singleUser, host); //$NON-NLS-1$
		} else {
    		emailObj.description = this.messages.ProjectAreaEditor_37;
		}
		var projectAreaId = this.itemId;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.ProcessRoleDialog"); //$NON-NLS-1$
		if (dialogWidget == null) {
			var invitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog(emailObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.InvitationCustomizationDialog", //$NON-NLS-1$
				primaryTitle: this.messages.ProjectAreaEditor_40,
				contentNode: invitationDialog.domNode,
				width: dojo.isIE ? "48em" : "46em", //$NON-NLS-1$ //$NON-NLS-2$
				execute: function(dialogObj){
						var params = {
							subject: dialogObj.getEmailSubject(),
							message: dialogObj.getEmailBody(),
							cc: dialogObj.getCopySelf() ? getAuthenticatedContributor().emailAddress : EMPTY,
							projectAreaUuid: projectAreaId
						};
						params["jsonInvitees"] = dojo.toJson(invitees); //$NON-NLS-1$
						var srh = new ServiceResponseHandler(this.targetObj, "handleInvitationResponse", "handleInvitationError"); //$NON-NLS-1$ //$NON-NLS-2$
						this.targetObj.showLink = showLink;
						if (invitees.length == 1) {
							this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_44;
						} else {
							this.targetObj.messageToDisplay = this.targetObj.messages.ProjectAreaEditor_43;
						}
						ProcessClient.generateTeamInvitations(params, srh);
        				this.targetObj.displayPendingMessage(this.targetObj.messages.ProjectAreaEditor_41);
				}	
			});
			dialogWidget.targetObj = this;
			dialogWidget.invitationDialogObj = invitationDialog;
			invitationDialog.emailSubject.focus();
			this.connectHandles.push(dojo.connect(invitationDialog.cancelButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(invitationDialog.finishButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				this.execute(this.invitationDialogObj);
				this.close();
			}));
		}
		else {
			dialogWidget.invitationDialogObj.reset(emailObj);
			dialogWidget.targetObj = this;
		}
	},
	
	chooseTeamInvitees: function(newMemberIds) {
		var newMemberArray = new Array();
		dojo.forEach(newMemberIds, function(itemId) {
			dojo.forEach(this.allMembers, function(member) {
				if (member.itemId === itemId) {
					newMemberArray.push(member);
				}
			})
		}, this);

		var mixinObj = new Object();
		mixinObj.newMembers = newMemberArray;
		
		var workbenchNode = dojo.byId("workbench"); //$NON-NLS-1$
		var dialogWidget = dijit.byId("com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog"); //$NON-NLS-1$
		var self = this;
		if (dialogWidget == null) {
			var teamInvitationDialog = new com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog(mixinObj, workbenchNode);
			dialogWidget = new net.jazz.ajax.ui.internal.Dialog({id:"com.ibm.team.process.web.ui.internal.admin.projects.TeamInvitationDialog", //$NON-NLS-1$
				primaryTitle: this.messages.ProjectAreaEditor_42,
				contentNode: teamInvitationDialog.domNode,
				width: dojo.isIE ? "38em" : "36em", //$NON-NLS-1$ //$NON-NLS-2$
				execute: function() {
					var invitees = this.teamInvitationDialogObj.getChosenMembers();
					if (invitees.length > 0) {
						self.customizeAndSendTeamInvitation(invitees, this.teamInvitationDialogObj.singleUser, true);
					}
				}
			});
			dialogWidget.targetObj = this;
			dialogWidget.teamInvitationDialogObj = teamInvitationDialog;
			teamInvitationDialog.okButton.focus();
			this.connectHandles.push(dojo.connect(teamInvitationDialog.cancelButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.close();
			}));
			this.connectHandles.push(dojo.connect(teamInvitationDialog.okButton, "onclick", dialogWidget, function (e) { //$NON-NLS-1$
				this.execute();
				this.close();
			}));
		}
		else {
			dialogWidget.teamInvitationDialogObj.repopulate(membersObj);
			dialogWidget.targetObj = this;
		}
	},
	
	handleInvitationResponse: function(response) {
		this.displaySuccessMessage(this.messageToDisplay, this.showLink);
	},
	
	handleInvitationError: function(err) {
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_45));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	adminRemoveHandler: function (e) {
		if (this.pendingAdminChanges["remove"] == null) { //$NON-NLS-1$
			this.pendingAdminChanges["remove"] = new Array(); //$NON-NLS-1$
		}
		var rowNode = e.target;
		while (rowNode.tagName !== "TR") { //$NON-NLS-1$
			rowNode = rowNode.parentNode;
		}
		var selectedUser = rowNode.userObj;
		var itemId = selectedUser.itemId;
		
		this.pendingAdminChanges.remove.push(itemId);
		for (var j=0; j < this.allAdmins.length; j++) {
			if (itemId === this.allAdmins[j].itemId) {
				this.allAdmins.splice(j,1);
				break;
			}
		}
		if (this.pendingAdminChanges.add != null) {
			for (var j=0; j < this.pendingAdminChanges.remove.length; j++) {
				if (this.pendingAdminChanges.add[j] == itemId) {
					this.pendingAdminChanges.add.splice(j,1);
					break;
				}
			}
		}
		this.setDirty(true);
		this.populateAdmins(this.allAdmins);
	},
	
	addNewMembers: function (newMembers) {
		if (newMembers != null) {
			if (newMembers.length > 0) {
				this.setDirty(true);
				if (this.pendingMemberChanges["add"] == null) { //$NON-NLS-1$
					this.pendingMemberChanges["add"] = new Array(); //$NON-NLS-1$
				}
			}
			for (var i=0; i < newMembers.length; i++) {
				var member = newMembers[i];
				member.itemId = member.itemId;
				member.processRoles = [{id: "default"}]; //$NON-NLS-1$
				member.savedProcessRoles = [{id: "default"}]; //$NON-NLS-1$
				this.allMembers.push(member);
				this.pendingMemberChanges.add.push(member.itemId);
				if (this.pendingMemberChanges.remove != null) {
					for (var j=0; j < this.pendingMemberChanges.remove.length; j++) {
						if (this.pendingMemberChanges.remove[j] == member.itemId) {
							this.pendingMemberChanges.remove.splice(j,1);
							break;
						}
					}
				}
			}
		}
		this.populateMembers(this.allMembers);
	},
	
	addNewAdmins: function (newAdmins) {
		if (newAdmins != null) {
			if (newAdmins.length > 0) {
				this.setDirty(true);
				if (this.pendingAdminChanges["add"] == null) { //$NON-NLS-1$
					this.pendingAdminChanges["add"] = new Array(); //$NON-NLS-1$
				}
			}
			for (var i=0; i < newAdmins.length; i++) {
				var admin = newAdmins[i];
				admin.itemId = admin.itemId;
				admin.processRoles = [{id: "default"}]; //$NON-NLS-1$
				admin.savedProcessRoles = [{id: "default"}]; //$NON-NLS-1$
				this.allAdmins.push(admin);
				this.pendingAdminChanges.add.push(admin.itemId);
				if (this.pendingAdminChanges.remove != null) {
					for (var j=0; j < this.pendingAdminChanges.remove.length; j++) {
						if (this.pendingAdminChanges.remove[j] == admin.itemId) {
							this.pendingAdminChanges.remove.splice(j,1);
							break;
						}
					}
				}
			}
		}
		this.populateAdmins(this.allAdmins);
	},
	
	handleChange: function (e) {
		if (e.target.value != e.target.savedValue) {
			e.target.changePending = true;
			this.setDirty(true);
		}
		else {
			e.target.changePending = false;
			if (!this.changesPending()) {
				this.setDirty(false);
			}
		}
	},
	
	setDirty: function (isDirty) {
		this.enableSaveButton(isDirty);
		if (isDirty) {
			this.modifiedFlag.style.display = "inline"; //$NON-NLS-1$
		}
		else {
			this.modifiedFlag.style.display = NONE;
		}
	},
	
	enableSaveButton: function(isDirty) {
		if (isDirty && this.name.value && (!this.isNew || this.processSelector.selectedIndex > -1)) {
			this.saveButton.disabled = false;
		} else {
			this.saveButton.disabled = true;
		}
		
	},
	
	changesPending: function () {
		for (var i=0; i < this.inputFields.length; i++) {
			if (this.inputFields[i].changePending) {
				return true;
			}
		}
		for (var i in this.pendingMemberChanges) {
			return true;
		}
		for (var i in this.pendingAdminChanges) {
			return true;
		}
		return false;
	},
	
	handleSave: function (e) {
		dojo.stopEvent(e);
		this.saveButton.disabled = true;
		var saveObj = {
			itemId: this.itemId
		};
		for (var i=0; i < this.inputFields.length; i++) {
			if (this.inputFields[i].changePending) {
				saveObj[this.inputFields[i].name] = this.inputFields[i].value;
			}
		}
		saveObj["jsonMembers"] = dojo.toJson(this.pendingMemberChanges); //$NON-NLS-1$
		saveObj["jsonAdmins"] = dojo.toJson(this.pendingAdminChanges); //$NON-NLS-1$
		if (this.isNew) {
			if (this.processSelector != null) {
				saveObj["processUuid"] = this.processSelector.value; //$NON-NLS-1$
        		saveObj["processLocale"] = this.processSelector.options[this.processSelector.selectedIndex].locale; //$NON-NLS-1$
			}
		}
		if (saveObj["processLocale"] === null || saveObj["processLocale"] === undefined) { //$NON-NLS-1$ //$NON-NLS-2$
    		saveObj["processLocale"] = this.processLocale ? this.processLocale : EMPTY; //$NON-NLS-1$
		}
		var msg = this.validateRequired(saveObj);
		if (msg != null && msg != EMPTY) {
			this.displayErrorMessage(msg);
		}
		else {
			var srh = new ServiceResponseHandler(this, "handleSaveResponse", "handleSaveError"); //$NON-NLS-1$ //$NON-NLS-2$
			ProcessClient.postProjectArea(saveObj, srh);
			if (this.isNew) {
				this.displayPendingMessage(this.messages.ProjectAreaEditor_24);
			}
			else {
				this.displayPendingMessage(this.messages.ProjectAreaEditor_25);
			}
		}
	},
	
	validateRequired: function (saveData) {
		if (saveData.name == EMPTY || (this.isNew && saveData.name == null)) {
			this.togglePrimaryField(MODE_EDIT);
			return this.messages.ProjectAreaEditor_26;
		}
		if (this.isNew && (saveData.processUuid == null || saveData.processUuid == EMPTY)) {
			if (this.processList.options.length == 0) {
				return this.messages.ProjectAreaEditor_27;
			}
			else {
				this.processList.focus();
				return this.messages.ProjectAreaEditor_28;
			}
		}
	},
	
	handleSaveResponse: function (response) {
		if (this.pendingMemberChanges.add != null && this.pendingMemberChanges.add.length > 0) {
			var currentUser = getAuthenticatedContributor();
			var newMemberIds = dojo.filter(this.pendingMemberChanges.add, function(memberId) {
				return memberId != currentUser.itemId;
			});
			if (newMemberIds.length > 0) {
				if (this.isNew && response) {
					// in this case we'll be destroying the page and creating a new one
					// so we have to save the member ids in a cookie
					dojo.cookie(TEAM_INVITATION_COOKIE_NAME, dojo.toJson(newMemberIds));
				} else {
					// not destroying the page, so call directly
        			this.chooseTeamInvitees(newMemberIds);
				}
			}
		}
		
		if (this.isNew && response) {
			dojo.cookie(MSG_COOKIE_NAME, this.messages.ProjectAreaEditor_29);
			PlatformUI.getWorkbench().unregisterBodyClickHandler(this.navigateAwayHandle);
			this.navigateAwayHandle = null;
			PlatformUI.getWorkbench().unregisterOnBeforeUnloadHandler(this.onBeforeUnloadHandle);
			this.onBeforeUnloadHandle = null;
			document.location.href = "#action=" + PROJECT_AREA_EDITOR + "&itemId=" + response; //$NON-NLS-1$ //$NON-NLS-2$
		}
		else {
			this.refresh();
			this.displaySuccessMessage(this.messages.ProjectAreaEditor_30, true);
		}
	},
	
	handleSaveError: function (err) {
		this.saveButton.disabled = false;
		var msg = document.createElement(DIV);
		msg.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_31));
		if (err.message != null && err.message != EMPTY) {
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createElement(BR));
			msg.appendChild(document.createTextNode(err.message));
		}
		this.displayLongErrorMessage(msg);
	},
	
	onRefresh: function (e) {
		dojo.stopEvent(e);
		if (this.changesPending() && !confirm(this.messages.ProjectAreaEditor_32)) {
			return;
		}
		this.refresh();
	},
	
	displaySuccessMessage: function (msg, showManagerLink) {
		this.displayMessage(msg,"successMsg"); //$NON-NLS-1$
		if (showManagerLink) {
			this.messageBox.appendChild(document.createTextNode(" ")); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			link.href = "#action=" + MANAGER; //$NON-NLS-1$
			link.appendChild(document.createTextNode(this.messages.ProjectAreaEditor_33));
			this.messageBox.appendChild(link);
		}
	},
	
	displayPendingMessage: function (msg) {
		this.displayMessage(msg,"pendingMsg"); //$NON-NLS-1$
	},
	
	displayErrorMessage: function (msg) {
		this.displayMessage(msg, "errorMsg"); //$NON-NLS-1$
	},
	
	displayMessage: function (msg, cssClass) {
		dojox.data.dom.removeChildren(this.messageBox);
		dojox.data.dom.removeChildren(this.longMessageBox);
		this.longMessageBox.className = EMPTY;
		this.messageBox.className = "message shortMsg " + cssClass; //$NON-NLS-1$
		this.messageBox.appendChild(document.createTextNode(msg));
	},
	
	displayLongSuccessMessage: function (msg) {
		if (dojo.isString(msg)) {
			msg = document.createTextNode(msg);
		}
		this.displayLongMessage(msg,"successMsg"); //$NON-NLS-1$
	},
	
	displayLongErrorMessage: function (msg) {
		if (dojo.isString(msg)) {
			msg = document.createTextNode(msg);
		}
		this.displayLongMessage(msg, "errorMsg"); //$NON-NLS-1$
	},
	
	displayLongMessage: function (msg, cssClass) {
		dojox.data.dom.removeChildren(this.messageBox);
		this.messageBox.className = EMPTY;
		dojox.data.dom.removeChildren(this.longMessageBox);
		this.longMessageBox.className = "message longMsg " + cssClass; //$NON-NLS-1$
		this.longMessageBox.appendChild(msg);
	},
	
	destroy: function () {
		dojo.forEach(this.connectHandles, function (handle) {
			dojo.disconnect(handle);
		});
		this.inherited(arguments);
	}
});

})();