/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.common.WorkLoadInformation"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.ProgressInformation"); //$NON-NLS-1$

(function() {

var HOUR= 60 * 60 * 1000;

dojo.declare("com.ibm.team.apt.web.ui.internal.common.WorkLoadInformation", //$NON-NLS-1$ 
			  [com.ibm.team.apt.web.ui.internal.common.ProgressInformation], {

	constructor: function(workLoadItemDTO) {
		if (workLoadItemDTO != null) {
			this._assignment= workLoadItemDTO.assignment;
			this._usesDefaultAssignment= workLoadItemDTO.usesDefaultAssignment;
			this._usesDefaultLocation= workLoadItemDTO.usesDefaultLocation;
			this._absences= workLoadItemDTO.absences;
		}
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------

	getAssignment: function() {
		return this._assignment;
	},

	isUsingDefaultAssignment: function() {
		return this._usesDefaultAssignment;
	},

	isUsingDefaultLocation: function() {
		return this._usesDefaultLocation;
	},

	getAbsences: function() {
		return this._absences;
	},

	__sentinel: null // terminates this class definition
});

})();
