/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
({
	// Shared
	'filter': "Type to filter",
	'del': "Delete",
	'delConfirmPrivate': "Are you sure you want to delete ${0}?",
	'loading': "Loading...",
	'addViewletText': "Add Viewlet",
	'profileTitle': "${0}'s Profile",  // ${0} is the user's name - 's denotes the possessive
	'refresh': "Refresh",
	'save': "Save",
	'cancel': "Cancel",
	'allHeading': "All Dashboards",
	
	// Dashboard Page
	'dashboardTitleWithTab': "Dashboard: ${0} > ${1}",
	'dashboardTitle': "Dashboard: ${0}",
	'allUsersTitle': "Dashboards: All Dashboards > All Users",
	'allTeamAreasTitle': "Dashboards: All Dashboards > All Team Areas",
	'dashboardsGenericTitle': "Dashboards",
	'connectionFailure': "The server may be offline or your internet connection may be down. Please check your connection and try again.",
	'errorRetrieving': "An error occured while retrieving the dashboard:",
	'restoreFailure': "The dashboard could not be restored because it has been modified by ${0}. Please refresh to see the latest content.",
	'saveFailure': "The dashboard could not be saved because it has been independently modified in another browser. Please refresh to see the latest content.",
	'restoreLockedOverride': "${0} is currently editing this dashboard. Would you like to override and restore anyway? (They will be unable to save their changes)",
	
	// Dashboard Container
	'navigateAwayPrefix': "Are you sure you want to navigate away from this page? \n\n",
	'navigateAwaySuffix': "\n\nPress OK to continue, or Cancel to stay on the current page.",
	'unsavedWork': "You have unsaved work on the Dashboards page. ", //preserve space after the period
	'unsavedChanges': "You have unsaved changes. ", //preserve space after the period
	'editingContents': "You are currently editing one or more viewlets on the Dashboards page. ", //preserve space after the period
	'editingContentsUnload': "You are currently editing one or more viewlets. ", //preserve space after the period
	'willDiscard': "If you continue your changes will be discarded.",
	'canReturn': "You can change pages but must remember to return to Dashboards to save your changes.",
	'viewletDefinitionsError': "Unable to retrieve viewlet definitions. ", //preserve space after the period
	
	// Dashboard Item
	'itemEditStaleSpecific': "This dashboard was independently modified by ${0}. Click OK to refresh and see the latest changes.",
	'itemEditStaleGeneral': "This dashboard was independently modified and needs to be reloaded. Click OK to see the latest changes.",
	'itemEditLocked': "${0} is currently editing this dashboard. Would you like to override and edit anyway? (they will be unable to save their changes)",
	'itemEditError': "An internal error occured; unable to enter edit mode: ${0}",
	'itemSaveStaleSpecific': "The dashboard could not be saved because it has been modified by ${0}. Please refresh to see the latest content.",
	'itemSaveStaleGeneral': "The dashboard could not be saved because it independently modified in another browser. Please refresh to see the latest content.",
	'itemSaveLocked': "The dashboard could not be saved because it is being edited by ${0}. Please refresh to see the latest content.",
	
	// Viewlet Page
	'addViewletRemoteError': "Add Viewlet remote error: ",
	'viewletNotFetched': "The viewlet definition could not be fetched: ",
	'noViewlets': "There are no viewlets in this tab.",
	'noViewletsAdd': "To add some, click on the <0>${0}</0> link located at the top right of the dashboard.",
	
	// Draggable Tabs
	'newTab': "New tab",
	'rename': "Rename",
	'deleteText': "Delete",
	'layout': "Layout",   // The layout of the dashboard (number of columns)
	'oneColumn': "1 Column",
	'twoColumns': "2 Columns",
	'threeColumns': "3 Columns",
	'deletingTab': "Deleting Tab",
	'deletingTabConfirm': "Are you sure you want to delete ${0}?",
	'deleteLastTab': "The last tab cannot be deleted.",
	'creatingTab': "Creating Tab",
	
	// Viewlet Container
	'showHeader': "Show header",
	'hideHeader': "Hide header",
	'editContents': "Edit Contents",
	'editSettings': "Edit Settings",
	'duplicateViewlet': "Duplicate Viewlet",
	'close': "Close",
	'copyOf': "Copy of ",
	'closeViewlet': "Are you sure you want to close this viewlet?",
	'stopEditingConfirm': "Viewlet \"${0}\" is currently being edited.  If you continue, your changes to this viewlet will be lost. \n\nAre you sure you want to continue?",
	'zoom': "Zoom",
	'menu': "Menu",
	'expand': "Expand",
	'collapse': "Collapse",
	
	// All Dashboards
	'allTeams': "All Team Areas",
	'allTeamsProj': "Project area:",
	'allTeamsNone': "No team areas found.",
	'allTeamsNoneMatch': "No team areas match the current filter.",
	'allUsers': "All Users",
	'allUsersRelated': "Related",
	'allUsersAll': "All",
	'allUsersPrev': "Previous",
	'allUsersNext': "Next",
	'allUsersOf': "of",
	'allUsersShowingSingular': "Showing ${0} user on your teams.",
	'allUsersShowingPlural': "Showing ${0} users on your teams.",
	'allUsersNoRelated': "No related users.",
	'allUsersNone': "No matching users found.",
	'allUsersNoTeamMatch': "No users on your teams match the current filter.",
	
	// Left Nav
	'leftPersonalTitle': "My Dashboards",
	'leftSharedTitle': "Shared Dashboards",
	'leftRecentTitle': "Recently Viewed",
	'leftCreateButton': "Create Dashboard",
	'leftProfileLink': "My Profile",
	'leftSearchTooltip': "Search",
	'leftSearchDefaultText': "Type to search",
	'leftSearchScopeAll': "All Dashboards",
	'leftSearchScopeAllTeams': "All Team Dashboards",
	'leftSearchScopeAllProjs': "All Profile Dashboards",
	'leftSearchNoDash': "No dashboards found",
	'leftSearchNoTeam': "No teams found",
	'leftSearchNoProj': "No profiles found",
	'leftSearchError': "Error: ${0}",
	'leftSearchErrorContact': "Error contacting server",
	'leftSearchUsers': "Users (${0})",
	
	// Meta Nav
	'connectionError':"Connection error: The server is offline or your internet connection is down. Your most recent action may not have been saved.",
	'communicationError': "An error occurred while communicating with the server.",
	'archivedContributor': "Note: The user associated with this dashboard is archived and no longer in use.",
	'archivedTeam': "Note: The team associated with this dashboard is archived and no longer in use.",
	'archivedProject': "Note: The project associated with this dashboard is archived and no longer in use.",
	'reload': "Reload",
	'autoSave': "Auto-save",
	'restoreDefault': "Restore Default",
	'confirm': "You will lose your changes.  Are you sure? \n(Click Okay to discard changes or Cancel to resume editing)",  //  "\n" is required
	'dashboardModified': "This dashboard has been modified",
	'addNewTab': "Add New Tab",
	
	// MetaNav: Delete Dialog Constants
	'deleteOwnPublicDashboard': "Are you sure you want to delete your profile?",
	'deleteOtherPublicDashboard': "Are you sure you want to delete ${0}'s profile?",  // ${0} is the user's name - 's denotes the possessive
	'deleteProcessDashboard': "Are you sure you want to delete the ${0} dashboard?",
	
	'restoreOwnPublicDashboard': "Are you sure you want to restore your profile to its template?",
	'restoreOtherPublicDashboard': "Are you sure you want to restore ${0} profile to its template?",
	'restoreProcessDashboard': "Are you sure you want to restore the ${0} dashboard to its template?",
	
	// Viewlet Chooser
	'viewletChooser': "Viewlet Chooser",
	'selectFromChooser': "Select a viewlet from the chooser to add it to your dashboard.",
	'viewletCategoryDescription': "Viewlet category.",
	'appliesTo': "Applies to:",
	'description': "Description:",
	'preview': "Preview:",
	'appliesToTeams': "Teams",
	'appliesToProjects': "Projects",
	'appliesToProjectsTeams': "Projects &amp; teams", // "&amp;" represents the "&" character and should not be translated
	'appliesToContributors': "Contributors",
	'appliesToAll': "Projects, teams &amp; contributor", // "&amp;" represents the "&" character and should not be translated
	'appliesToUnknown': "Unknown",
	'icon': "icon",
	'viewletPreviewImage': "Viewlet Preview Image",
	'noDescriptionSpecified': "No description was specified.",

	// Error Page
	'dashboardErrorMessage': "An internal system error occured while retrieving the dashboard.",
	'dashboardErrorTitle': "Error!",
	
	// Viewlet Settings
	'settingsReq': "required field",
	'settingsLoadingOpts': "Loading Options...",
	'settingsAppearance': "Appearance",
	'settingsTitle': "Title",
	'settingsTitleDesc': "The text that appears in the heading area of the viewlet.",
	'settingsTitleDesc2': "Only editable when not using a computed title.",
	'settingsTitleComp': "Use computed title",
	'settingsTitleCompDesc': "Indicates whether the viewlet should automatically determine its title.",
	'settingsTrim': "Trim",
	'settingsTrimDesc': "Trim colour selection affects viewlet borders and background.",
	'settingsBackgr': "Show Background Color",
	'settingsBackgrDesc': "Indicates whether trim color should fill the background of the viewlet.",
	'settingsPrefs': "Preferences",
	'settingsPrefsEdit': "Edit...",
	'settingsScope': "Scope",
	'settingsScopeType': "Scope type",
	'settingsScopeTypeDesc': "Set the scope of the viewlet to a specific category or allow the viewlet to determine its scope automatically.",
	'settingsScopeSel': "Current selection",
	'settingsScopeSelContributorDesc': "Set the scope of the viewlet to a specific contributor or allow the viewlet to determine its scope automatically.",
	'settingsScopeSelTeamDesc': "Set the scope of the viewlet to a specific team area or allow the viewlet to determine your team area automatically.",
	'settingsScopeSelProjectDesc': "Set the scope of the viewlet to a specific project area or allow the viewlet to determine your project area automatically.",
	'settingsScopeSub': "Include sub-teams",
	'settingsScopeSubDesc': "Indicates whether the viewlet should include sub-teams in the current scope.",
	'settingsScopeSelContributor': "Select Contributor",
	'settingsScopeNone': "None",
	'settingsScopeMore': "More...",
	'settingsScopeAuto': "Auto",
	'settingsScopeContributor': "Contributor",
	'settingsScopeTeam': "Team Area",
	'settingsScopeProj': "Project Area",
	
	// Dashboard Welcome
	'welcomeUserCreate': "You do not have a profile dashboard. To get started, <0>create the dashboard</0>.",
	'welcomeUserNoPermission': "You do not have permission to create a profile dashboard. To get started, contact your system administrator to request permission.",
	'welcomeUserNone': "${0} does not have a profile dashboard.",
	'welcomeProcessCreate': "This dashboard does not exist. To get started, <0>create the dashboard</0>.",
	'welcomeProcessNoPermission': "This dashboard does not exist. To get started, contact a user who has permission to create this dashboard or request permission from your system administrator.",
	'welcomeErrorExists': "This dashboard has already been created by ${0}. Click OK to view it.",
	
	// HTML Utility
	'msgHTMLErrorScriptTags': "[Error] Insecure content detected.\nThe use of script tags is not permitted:  '<script></script>'.\nPlease remove all occurrences of these tags before saving.",
	'msgHTMLErrorQualifiers': "[Error] Insecure content detected.\nThe use of javascript qualifiers is not permitted:  'javascript:'.\nPlease remove all occurrences of these qualifiers before saving.",
	'msgHTMLErrorEventHandlers': "[Error] Insecure content detected.\nThe use of event handlers is not permitted:  'onxxxxx=\"script\"'.\nPlease remove all occurrences of these handlers before saving.",			
	
	// Error Viewlet
	'errorViewletHeading': "There was a problem loading the viewlet:",
	'errorViewletMessage': "The viewlet definition ${0} does not exist."
})
