/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.viewlets.web.ui.internal.utils.UUIDUtility");

/*
 * Imports 
 */


(function() {

/*
 * Class 
 */
com.ibm.team.dashboard.viewlets.web.ui.internal.utils.UUIDUtility = {
	
	/*
 	* Static Variables
 	*/	
	_UUID_LENGTH: 23,
	_UUID_FIRST_CHARACTER: "_",

	/*
 	 * Public Method
 	 * 
 	 * @param String value
 	 * @return boolean
 	 */	
	isValidUUID: function(value) {
		// See com.ibm.team.repository.common.UUID.validateUUID(char[])
		// e.g. _H9EB5esEEdycivs5PH0c-g
        if (value.length != this._UUID_LENGTH) {
			// UUID has to be the proper fixed length
            return false;
        } else if (value.charAt(0) != this._UUID_FIRST_CHARACTER) {
			// UUID has to start with an underscore
            return false;
        }
        // Note:  All of the characters in a UUID must be in the range of MIME64
        // encoding characters
		// Skipping this check for performance reasons
		return true;
	}

};


})();

