/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration, presented in 
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.BooleanAttributePart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="BooleanAttributePart">' +
						'<div dojoAttachPoint="_content" style="position:relative;left:10px;max-width: 15.6em;"></div>' +
						'</div>',

		postCreate: function() {
			if(this.values && this.values[0]) {
				for(var i=0;i<this.values.length;i++) {
					if(this.values[i].id != null) {
						this.values[i] = (this.values[i].id ==true) || (this.values[i].id == "true");
					} else {
						this.values[i] = (this.values[i]==true) || (this.values[i] == "true");
					}				
				}
			} else {
				this.values = [ false ]
			}

			if(this.values[0])
				this.values[0] = true;

			if(!this.attributeValue) {
				this.attributeValue = {	
						label: this.values[0]
					}
			}
				this.inputCheckbox = document.createElement("INPUT");
				this.inputCheckbox.type = "checkbox";
				this.inputCheckbox.checked = this.values[0];
				this._content.appendChild(this.inputCheckbox);

			if(this.parentController.pageController.isGuest()) {
				this.inputCheckbox.disabled="true";
			}
			
			this.inputCheckbox._parentWidget = this.parentWidget;
			this.connect(this.inputCheckbox, "onchange", this._handleChange);

		},
		_handleChange: function (e) {
			e.target._parentWidget._handleDirtyingEvent(e);
		},
		setReadOnly: function(isReadOnly) {
			this.inputCheckbox.disabled=isReadOnly;
		},
		getFormElementValues: function(formElements) {
			var value = this.getValue();		
			formElements[this.attributeId] = ""+ value;
		},
		setFormElementValues: function(retainedState){
			var value = retainedState[this.attributeId];
			if(value == null) return;
			if(value) {
				this.inputCheckbox.checked = true;
			} else {
				this.inputCheckbox.checked = false;
			}
			},
	     getValue: function() {
			return this.inputCheckbox.checked;
		 }
	}
);

})();
