/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.LinksPart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuDropDownActionWidget");
dojo.require("net.jazz.ajax.ui.internal.ImagePreview");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that shows the Links Section
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var SelectWorkItemDialog = com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemDialog;
var ImagePool				= com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
var ImagePreview			= net.jazz.ajax.ui.internal.ImagePreview;
// These variables must match LinkCommand.java
var ADD_LINK= "addLink";
var REMOVE_LINK= "removeLink";

// The following must match WorkItemRestService.java
var UPDATE_LINKS = "updateLinks";

// TODO eventually get this stuff from the server so we don't have duplicated
// model logic on the client
//

var EDITABLE_LINK_TYPES = EDITABLE_LINK_TYPES= { // Coordinate changes with constructor
				related: {
					key: "related",
					id: "com.ibm.team.workitem.linktype.relatedworkitem",
					isSingleValued: false,
					isSource: false
				},
				duplicateOf: {
					key: "duplicateOf",
					id: "com.ibm.team.workitem.linktype.duplicateworkitem",
					isSingleValued: true,
					isSource: true
				},
				blocks: {
					key: "blocks",
					id: "com.ibm.team.workitem.linktype.blocksworkitem",
					isSingleValued: false,
					isSource: false
				},
				dependsOn: {
					key: "dependsOn",
					id: "com.ibm.team.workitem.linktype.blocksworkitem",
					isSingleValued: false,
					isSource: true
				},
				children: {
					key: "children",
					id: "com.ibm.team.workitem.linktype.parentworkitem",
					isSingleValued: false,
					isSource: true
				},
				parent: {
					key: "parent",
					id: "com.ibm.team.workitem.linktype.parentworkitem",
					isSingleValued: true,
					isSource: false
				}
			};
var headingColor = "#666668";
var columnLayout = {
	name: {
		style: {
			fontWeight: "bold",
			margin: "0 0 0 8px",
			color: headingColor,
			width: "100%"
		}
	}
}

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.LinksPart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="LinksPart SectionPart">' +
						'<span dojoAttachPoint="_sectionMenuSPAN"></span>' +
						'<div dojoAttachPoint="_contentNode">' +
						'</div>' +
						'<BR></div>',
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			
			EDITABLE_LINK_TYPES.related.displayName = this.messages.labelRelated;
			EDITABLE_LINK_TYPES.duplicateOf.displayName= this.messages.labelDuplicateOf;
			EDITABLE_LINK_TYPES.blocks.displayName= this.messages.labelBlocks;
			EDITABLE_LINK_TYPES.dependsOn.displayName= this.messages.labelDependsOn;
			EDITABLE_LINK_TYPES.children.displayName= this.messages.labelChildren;
			EDITABLE_LINK_TYPES.parent.displayName= this.messages.labelParent;
			columnLayout.name.label=  this.messages.labelLink;
		},
		postCreate: function() {	
			this._childWidgets = [];
			this.isLinkManager = true; //marker
			this._isInitialized = false;
			this._workItem = this.parentController._workItem;
			
			this._linkTypes = [];
			if (this._workItem.linkTypes) {
				for (var i = 0; i < this._workItem.linkTypes.length; i++) {
					this._linkTypes.push(this._workItem.linkTypes[i]);
				}
			}
		},
		destroyWidget: function() {
			this.resetWidget();
			this.destroy();
		},
		resetWidget: function() {
			this.parentController.pageController.removeAllMouseListeners(this);
			for(var i = 0; i< this._childWidgets.length; i++) {
				if(this._childWidgets[i].destroyWidget)
					this._childWidgets[i].destroyWidget();
				this._childWidgets[i] = null;
			}

			this._childWidgets = [];
			dojox.data.dom.removeChildren(this._contentNode);
		},
		/*
		 * Load the tab when it is shown
		 */
		showWidget: function() {
			if(this._isInitialized) return;
			this._isInitialized = true;
			this.refresh();
		},
		
		/*
		 * Setup the page and read the states and types 
		 */
		refresh: function() {
			if (!this.parentController.pageController.isGuest()) {
				var actions = [];
				for (var key in EDITABLE_LINK_TYPES) {
					var action = EDITABLE_LINK_TYPES[key];
					actions.push(action);
				};
				var actionClass = com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuDropDownActionWidget;
				var menuClass = com.ibm.team.workitem.web.ui.internal.view.layout.SectionMenuWidget;
				this._sectionMenuWidget = WidgetUtil.createSectionMenu({
					domNode: this._sectionMenuSPAN,
					parentWidget: this,
					menuClass: menuClass,
					actionClass: actionClass,
					actionSelector: "_handleNewItemPressed",
					actionLabelSelector: "displayName",
					menuLabel: this.messages.buttonAdd,
					actions: actions
				});
				this._childWidgets.push(this._sectionMenuWidget);
			}
			this.resetWidget();			
			this._markDirtyIfDifferent();
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						isHeading: true,
						isFirst: true,
						noPadding: true
					};
			var listWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.SectionListWidget(creationArgs);
			
			var rowItems = [];
			for (var i = 0; i < this._linkTypes.length; i++) {
				// skip attachments
				if(this._linkTypes[i].id == "com.ibm.team.workitem.linktype.attachment") continue;
				
				var isLast = i == this._linkTypes.length;
				if (this._linkTypes[i] && this._hasLinks(this._linkTypes[i], true)) {
					var item = {};
					item.columnWidgets = [this._getRow(listWidget, this._linkTypes[i], /* isFirst */ i == 0, isLast) ];
					item.value  = this._linkTypes[i];
					item.value.isNotHighlighted = true;
					item.showDelete = false;
					rowItems.push(item);
					this._addLinkItems( this._linkTypes[i],rowItems, item);
				}
			}
			listWidget.setRows(
					{
						itemList: rowItems,
						deleteAction: {
								selector: "_handleDeleteItemPressed",
								title: this.messages.titleLinkDelete
						},
						restoreAction: {
								selector: "_handleRestoreItemPressed",
								title: this.messages.titleLinkRestore
						}
					}
					)
			this._contentNode.appendChild(listWidget.domNode);
			this._childWidgets.push(listWidget);	
			if( this.parentController.pageController.isGuest() && listWidget._tableWidget && listWidget._tableWidget._table) 
				listWidget._tableWidget._table.style.border="";
			this.parentController.updateHeaderValidation();

		},
		_hasLinks: function(linkType, showDeleted) {
			var links = linkType.linkDTOs
			for (var i = 0; i < links.length; i++) {
				if(showDeleted || !links[i]._isDeleted) return true;
			}
			return false;
		},
		_addLinkItems: function(linkType, rowItems, item) {
			var links = item.value.linkDTOs
			if(!links || links.length == 0) return;
			var target, targetType, id;
			for (var j = 0; j < links.length; j++) {
				var link = links[j];
				if(!link) continue;
				link.linkType = linkType;
//				if(link._isDeleted) continue;
				var node = document.createElement("SPAN");
				node.className = "SectionListChildRow SectionListLink"
				var img = document.createElement("IMG");
				img.src = ImagePool.LIST_ARROW;
				target = link.target;
				id = null;
				stateGroup = -1;
  				targetType = target ? target._eQualifiedClassName : null;
				if (target && target.attributes) {
					for (var i = 0; i < target.attributes.length; i++) {
						if (target.attributes[i].key == "id") {
							id = target.attributes[i].value.id;
							break;
						}
					}
					for (var i = 0; i < target.attributes.length; i++) {
						if (target.attributes[i].key == "stateGroup") {
							stateGroup = target.attributes[i].value.id;
							break;
						}
					}
				}
				var anchor;
				
				// if no comment, make the link the comment
				if((!link.comment || link.comment.length == 0)) {
					if(link.url) {
						link.comment = link.url;
					} else {
						if(link.linkType.itemType) {
							link.comment = link.linkType.itemType;	
						} else {
							if(link.linkType.id) {
								link.comment = link.linkType.id
							} else {
								link.comment = this.messages.labelLink;
							}
						}
					}
				}
				
				link.comment = this.splitText(link.comment);
				
				try {
				// If it is an attachment link (mentions)
				// If it is a work item link
				// Links to attachments are currently pointing to item descriptor not attachment
				// uncomment when links are correct 
//			  if (targetType && (targetType.indexOf("AttachmentDTO") != -1) && link && link.comment && link.url) {
//			  	anchor = document.createElement("A");
//			  	anchor.appendChild(document.createTextNode(link.comment));
//			  	anchor.target = "_blank";
//			  	anchor.href = link.url;
//			  	index = link.comment.lastIndexOf(".");
//			  	ext = index == -1 ? null : link.comment.substring(index + 1);
//			  	if (ext == "gif" || ext == "png" || ext == "jpeg" || ext == "jpg") {
//			  		new ImagePreview({
//			  			connectNode: [anchor],
//			  			src: anchor.href,
//			  			filename: link.comment
//			  		}, document.createElement("div"));
//			  	}
//			  }
//			  else {
			  	if (id && ((targetType && (targetType.indexOf("WorkItemDTO") != -1)) || (link.linkType && link.linkType.itemType && link.linkType.itemType.toLowerCase && link.linkType.itemType.toLowerCase() == "workitem"))) {
			  		anchor = document.createElement("A");
					anchor.href="#";
			  		anchor.appendChild(document.createTextNode(link.comment));
			  		this.connect(anchor, "onclick", this._handleWorkItemOpen);
			  		anchor.__jazzValue = link;
			  		anchor.__pageController = this.parentController.pageController;
			  	}
			  	else {
			  		// if it has a url and is a "related artifact" (url only), then it is a url item. Open in a new window.
							// Added a test to check if its an "internal url" (e.g., link to Build).
							// Added special case for "Included in build" links.
						    var url = link.url;
							if (url && link.linkType && 
							    (link.linkType.id == "com.ibm.team.workitem.linktype.relatedartifact" || 
							     link.linkType.id == "com.ibm.team.filesystem.workitems.change_set" ||
							     link.linkType.id == "com.ibm.team.build.linktype.includedWorkItems" ||
							     link.linkType.id == "com.ibm.team.build.linktype.reportedWorkItems")) {
							    var external = true;
							    var m = /com.ibm.team.scm.ChangeSet\/([A-Za-z0-9_\-]+)\?.*workspace=([A-Za-z0-9_\-]+)/.exec(url);
							    if (m) {
							    	url = "#action=com.ibm.team.scm.viewChangeSet&changeSetItemId=" + m[1] + "&workspaceItemId=" + m[2];
							    	external = false;
							    }
								anchor = document.createElement("A");
								anchor.appendChild(document.createTextNode(link.comment));
								anchor.href =  EditorUtil.removeHrefScripting(url);
								if(external && anchor.href.indexOf("error=Invalid%20URI") == -1) {
									anchor.target = "_blank";									
								}
							}
							else { // no link
								anchor = document.createTextNode(link.comment);
							}
						}
//					}
				} catch (e) {
					console.debug("Error creating link to: " + (link ? link.comment : "null link")); 
				}
				node.appendChild(img);
				if(stateGroup == 2) {
					dojo.addClass(anchor,"Strikeout");	
				};
				node.appendChild(anchor);
				
				var fakeWidget = {
					domNode: node
				};
				
				var linkItem = {};

				linkItem.columnWidgets = [ fakeWidget ];
				linkItem.value  = link;
				
				var itemId = link.itemId;
				if(!itemId && target && target.attributes) {
	  				var id;
				  	for(var i=0;i<target.attributes.length;i++) {
				  		 if(target.attributes[i].key=="itemId") {
					 		itemId = target.attributes[i].value.itemId;
							break;
				 		}
			  		}
				}
				
				var typeIdKey = link.linkType.id.replace(/\./g, "_").toLowerCase();
				var canBeDeleted = link.linkType.isUserDeleteable != false; 
				
				linkItem.itemId = itemId;
				linkItem.showDelete =canBeDeleted; 
				rowItems.push(linkItem);
			}
			
		},
		splitText: function(text) {
			if(!text) return text;
			
			// Max unbroken chars = 55. 
			// 55 ensures no clipping when the page is minimal width
			// Add a space if there are 55 unbroken chars without one
			return dojo.trim( text.replace(/[^ ]{55}/g, '$& ') );
		},
		_handleWorkItemOpen: function(e) {
			e.preventDefault();
			if(!e.target.__jazzValue) return;
			var link = e.target.__jazzValue;
			var target = link.target;
			if(target && target.attributes) {
			  var id;
  			  var targetType = target._eQualifiedClassName;
			  for(var i=0;i<target.attributes.length;i++) {
			  	 if(target.attributes[i].key=="id") {
				 	id = target.attributes[i].value.id;
					break;
				 }
			  }
			  if(id && ((targetType && (targetType.indexOf("WorkItemDTO") != -1)) || (link.linkType && link.linkType.itemType && link.linkType.itemType.toLowerCase && link.linkType.itemType.toLowerCase() == "workitem")) ) {
			  	e.target.__pageController._internalViewWorkItem(id);
			  } else { // should never happen
			  	if(e.target.__jazzValue.url) {
				  	window.location.href = e.target.__jazzValue.url;
				}
			  }
			}
		},
		addDuplicateLink: function() {
			this._openLinksDialog({
				label: this.messages.labelDuplicateOf,
				value: EDITABLE_LINK_TYPES.duplicateOf
			});
		}, 
		removeDuplicateLink: function() {
				var linkTypes = this._linkTypes;
				if(!linkTypes) return;
				for(var i = 0;i<linkTypes.length;i++ ){
					if(linkTypes[i].id == "com.ibm.team.workitem.linktype.duplicateworkitem" && linkTypes[i].isSource ) {
						for(var j=0;j<linkTypes[i].linkDTOs.length; j++) {
							if(!linkTypes[i].linkDTOs[j]._isDeleted)
								linkTypes[i].linkDTOs[j]._isDeleted = true;
						} 
					}
				}
				this.refresh();
		},
		_findInArray: function(item, array) {
			for(var i=0;i<array.length;i++){
				if(item.itemId == array[i].itemId) return true;
			}
			return false;
		},
		_markDirtyIfDifferent: function() {
			if(true) return; // TODO: Only enable when changed
			var trueLength = 0;
			for (var i = 0; i < this._linkTypes.length; i++) {
				if(!this._linkTypes[i]._isDeleted) {
					trueLength++;
					if (this._workItem.linkTypes) {
						if (!this._findInArray(this._linkTypes[i], this._workItem.linkTypes)) {
							this.parentWidget.parentController.markDirty();
							return;
						}
					}
				}
			}
			var workItemLinksTypesLength = this._workItem.linkTypes ? this._workItem.linkTypes.length : 0;
			if(trueLength != workItemLinksTypesLength) {
				this.parentWidget.parentController.markDirty();
				return
			}			

		},
//		_handleDeleteLinkType: function(e) {
//			e.target.parentWidget.deleteLinkType(e.target.value);
//		},
//		deleteLinkType:function(linkType) {
//			linkType._isDeleted = true;
//			this.refresh();
//			this._handleSubscriptionsSemanticChange();
//		},
		_getRow: function(listWidget, linkType, isFirst, isLast) {
			var layout = WidgetUtil.mergeObjects({}, columnLayout.name);
			layout.label = linkType.displayName;
			layout.isFirst = isFirst;
			layout.isLast = isLast;
			return listWidget.getLabelWidget(layout);
		},
	
		newLink: function(workItems, action) {
			workItems.sort(
				function(a, b) {
					aId= parseInt(a.id, 10);
					bId= parseInt(b.id, 10);
					return aId - bId;
				});
				
			// These are either work items or wrappers from the dialog
			for (var i=0; i<workItems.length; i++) {
				if(workItems[i].attributes && workItems[i].attributes.summary) {
					workItems[i]._linkComment = EditorUtil.getSummaryLabel(workItems[i]);
				} else {
					workItems[i]._linkComment = workItems[i].id + ": " + EditorUtil.restoreTags(workItems[i].summary);
				}
			}
			
			// Find or add the link type
			var linkType = this._findLinkType(action.value); 
			
			// Add the work items to the type's linkDTOs
			var workItem, wasUpdated=false;
			for (var i=0; i<workItems.length; i++) {
				if(this._workItem.itemId == workItems[i].workItemItemId) {
					alert(this.messages.msgLinkCannotReferenceItself);	
				}	else {
					wasUpdated = true;
					this._addItemToLinks(linkType, workItems[i]);
				}
			};
			if(!wasUpdated) return;
			this.parentWidget.parentController.markDirty();
			this.refresh();
		},
		_findLinkType: function(searchLinkType) {
			var linkType;
			var found = false;			
			for(var i=0;i<this._linkTypes.length;i++){
				if(this._linkTypes[i].id == searchLinkType.id && this._linkTypes[i].isSource == searchLinkType.isSource) {
					found = true;
					linkType =this._linkTypes[i]; 
					break;
				}
			}
			
			if(!found) {
				linkType = WidgetUtil.mergeObjects({}, EDITABLE_LINK_TYPES[searchLinkType.key]);
				linkType.itemType = "WorkItem";
				linkType._isNew = true;
				this._linkTypes.push(linkType);
			}
			
			if(!linkType.linkDTOs) {
				linkType.linkDTOs = [];
			}
			return linkType;
		},
		_addItemToLinks: function (linkType, item) {
			var links = linkType.linkDTOs
			var itemId = item.workItemItemId ? item.workItemItemId : item.itemId;
			var found = false;
			for(var i=0;i<links.length;i++){
				if(links[i].itemId == itemId) {
					found = true;
					links[i]._isDeleted = false;
					break;
				}
			}
			
			if (!found) {
				var link = {
					_isNew: true,
					id: item.id,
					itemId: itemId,
					comment: item._linkComment
				}
				var idAttr = {
					id: item.id
				}
				var target = {
					_eQualifiedClassName: "com.ibm.team.workitem.rest.dto:WorkItemDTO",
					attributes: [
							{ key: "id",
							  value: idAttr } ]
				}
				link.target = target;
				
				if (linkType.isSingleValued) {
					// mark all the other links deleted
					var newLinks = [];
					for (var i = 0; i < links.length; i++) {
						if (links[i].itemId != itemId) {
							if(!links[i]._isNew) {
								newLinks.push(links[i]);
							}
							links[i]._isDeleted = true;
						}
					}
					links = newLinks;
					linkType.linkDTOs = links; 
				}
				
				links.push(link);
			}	
		},
		hasDuplicateOfLink: function() {
				// If the work item has a duplicate link
				// and it hasn't been deleted
				// or it has been added
				// then it is ok, otherwise, show a message
				
				// Does the work item have duplicate links
				var currentDuplicates = [];
				var linkTypes = this._linkTypes;
				if(!linkTypes) return false;
				for(var i = 0;i<linkTypes.length;i++ ){
					if(linkTypes[i].id == "com.ibm.team.workitem.linktype.duplicateworkitem" && linkTypes[i].isSource ) {
						for(var j=0;j<linkTypes[i].linkDTOs.length; j++) {
							if(!linkTypes[i].linkDTOs[j]._isDeleted)
								currentDuplicates.push(linkTypes[i].linkDTOs[j].itemId);
						} 
					}
				}
				
//				var foundNewDuplicate = false;
//				var saveCommands = this.parentController._getSaveCommands();
//				if(saveCommands.updateLinks) {
//					for(var i=0;i<saveCommands.updateLinks.length;i++) {
//						var cmd = saveCommands.updateLinks[i];
//						if(cmd.cmd == "addLink" && cmd.end == "source" && cmd.type=="com.ibm.team.workitem.linktype.duplicateworkitem") {
//							foundNewDuplicate = true;
//						}
//						if(cmd.cmd == "removeLink" && cmd.end == "source" && cmd.type=="com.ibm.team.workitem.linktype.duplicateworkitem") {
//							for(var j=0;j<currentDuplicates.length;j++) {
//								if(currentDuplicates[j] == cmd.itemId) {
//									currentDuplicates.splice(j);
//									break;
//								}
//							}
//						}
//					}
//				}
//				
//			 return currentDuplicates.length > 0 || foundNewDuplicate;

			return currentDuplicates.length > 0
		},	
		_handleDeleteItemPressed: function(e) {
			if(e && e.target && e.target.parentWidget && e.target.parentWidget._deleteLink) {
				e.target.parentWidget._deleteLink(e.target);
			}
		},
		_handleRestoreItemPressed: function(e) {
			if (e && e.target && e.target.parentWidget && e.target.parentWidget._restoreLink) {
				e.target.parentWidget._restoreLink(e.target);
			}
		},
		_deleteLink: function(action) {
			var itemToDelete = action.value;
			
			// Find or add the link type
			var linkType = this._findLinkType(action.value.linkType);
			var links = linkType.linkDTOs; 
			var wasDeleted = false;
			if(itemToDelete.itemId) {
				for(var i=0;i<links.length;i++){
					if(links[i].itemId == itemToDelete.itemId) {
						links[i]._isDeleted = true;
						if(links[i]._isNew) {
							links.splice(i,1);
						}
						wasDeleted = true;
						break;
					}
				}
			} else {
				if(itemToDelete.url && itemToDelete.comment) {
					for(var i=0;i<links.length;i++){
					if(!links[i]._isDeleted && links[i].url && links[i].comment  && links[i].url == itemToDelete.url && links[i].comment == itemToDelete.comment) {
						wasDeleted = true;
						links[i]._isDeleted = true;
						if(links[i]._isNew) {
							links.splice(i,1);
						}
						break;
					}
				}	
				}		
			}
			
			if(wasDeleted) {
				this.parentWidget.parentController.markDirty();
			}
			this.refresh();
		},
		_restoreLink: function(action) {
			var itemToDelete = action.value;
			
			// Find or add the link type
			var linkType = this._findLinkType(action.value.linkType);
			var links = linkType.linkDTOs; 

			if(itemToDelete.itemId) {
				for(var i=0;i<links.length;i++){
					if(links[i].itemId == itemToDelete.itemId) {
						links[i]._isDeleted = false;
						break;
					}
				}
			} else {
				if(itemToDelete.url && itemToDelete.comment) {
					for(var i=0;i<links.length;i++){
					if(!links[i]._isDeleted && links[i].url && links[i].comment  && links[i].url == itemToDelete.url && links[i].comment == itemToDelete.comment) {
						links[i]._isDeleted = false;
						break;
					}
				}	
				}		
			}
			
			this.refresh();
		},
		_handleNewItemPressed: function(action) {
			this._openLinksDialog(action);
		},
		showLinksTab: function() {
			if(this.parentWidget.tabId) {
				var url = window.location.href;
				url = (url + "&").replace(/&&/g, "&");
				url = url.replace(/&tab=.+&/, "") + "&tab=" + this.parentWidget.tabId;
				window.location.href = url;
			}
		},
		_openLinksDialog: function(action) {
			if(!this.parentController.checkLogin()) return;
			var self= this;
			var title = dojo.string.substitute(this.messages.buttonAddLink, [ action.label ] );
			var params= {
				dialogTitle: title,
				allowsMultiple: !EDITABLE_LINK_TYPES[action.value.key].isSingleValued,
				parentController: this.parentWidget.parentController,
				parentElement: this.domNode,
				exclusionList: this.getCurrentLinks(),
				onOk: function(selectedWorkItems, action) {
					self.newLink(selectedWorkItems, action);
				},
				onClose: function() {
					self.parentController.focus();
				},
				action: action
			};
			new SelectWorkItemDialog(params);
		},
		/**
		 * Returns an array of the itemIds of the current linkTypes.
		 */
		getCurrentLinks: function() {
			var linkTypes= [];
			
			if(this._workItem) {
				linkTypes.push(this._workItem.itemId);				
			}
			for (var i=0; i<this._linkTypes.length; i++) {
				if(!this._linkTypes[i]._isDeleted) linkTypes.push(this._linkTypes[i].itemId);
			}
			
			return linkTypes;
		},
		
		
		//
		// Part API Metnods
		//
		setReadOnly: function(isReadOnly) {
		},
		getFormElementValues: function(formElements) {
		},	
		setFormElementValues: function(retainedState){
		},
		/*
		 * Add values to the updateLinks commands
		 *
		 */
		 getSaveCommands: function (allCommands) {
		 	if(!this._linkTypes) return allCommands;
			
		 	var commands = [];
			for(var i=0; i<this._linkTypes.length; i++) {
				this._getSaveCommandsForType(commands, this._linkTypes[i]);
			}
			
			var updateLinks = allCommands[UPDATE_LINKS] ? allCommands[UPDATE_LINKS] : [];
			
			for(var i=0;i<commands.length;i++){
				updateLinks.push(commands[i]);
			}
			
			if (commands.length > 0) {
				allCommands[UPDATE_LINKS] = updateLinks;
			}
			
			return allCommands;
		 },
		_getSaveCommandsForType: function(commands, linkType) {
			 var links = linkType.linkDTOs;
			 if(!links || links.length == 0 ) return;
			 var link;
			 for (var i = 0; i < links.length; i++) {
			 	link = links[i]
			 	if (link._isNew || this._workItem.id < 0) {
			 		if (!link._isDeleted) {
			 			// For a new approval, consolidate all commands into one command
							var command = {
								cmd: ADD_LINK,
								type: linkType.id,
								end: linkType.isSource ? "source" : "target",
								name: linkType.displayName // not needed... used in history
							}
							if(link.itemId) command.itemId = link.itemId;
							if(link.url) command.uri = link.url;
							if(link.comment) command.comment = link.comment;
							
							commands.push(command);
						}
					}
					else { // Not new
						if (link._isDeleted) {
							// For a new approval, consolidate all commands into one command
							var command = {
								cmd: REMOVE_LINK,
								type: linkType.id,
								end: linkType.isSource ? "source" : "target",
								name: linkType.displayName // not needed... used in history
							}
							if(link.itemId) command.itemId = link.itemId;
							if(link.url) command.uri = link.url;
							
							commands.push(command);
						}
					}
				}
		},
	     getValue: function() {
//			return this.inputWidget.getValue();
		 }
	}
);

})();
