/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.BarModes"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.WorkLoadBar"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var WorkLoadBar			= com.ibm.team.apt.web.ui.internal.view.widgets.WorkLoadBar;
var ProgressBar			= com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$ 

// publish methods
dojo.mixin(com.ibm.team.apt.web.ui.internal.view.plan.planneditems.BarModes,  {
	load: {
		id: "load", //$NON-NLS-1$
		label: MSGS.BARMODE_WORKLOAD,
		createBar: function(groupInfo, progressInfo, width, height) {
			if (!groupInfo.workLoad)
				return null;

			var constructorArgs= WorkLoadBar.constructorArgs(groupInfo.workLoad, width, height);
			return new WorkLoadBar(constructorArgs);
		}
	},
	
	progress: {
		id: "progress", //$NON-NLS-1$
		label: MSGS.BARMODE_PROGRESS,
		createBar: function(groupInfo, progressInfo, width, height) {
			if (!progressInfo)
				return null;

			var constructorArgs= ProgressBar.constructorArgs(progressInfo, width, height);
			return new ProgressBar(constructorArgs);
		}
	}
});

})();
