/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.DurationWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.internal.HoverPopup");
dojo.require("com.ibm.team.workitem.web.client.util"); 
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.TextWidget");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");

(function(){
	
var TextWidget= com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.TextWidget;
var Util= com.ibm.team.workitem.web.client.util;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.DurationWidget", TextWidget, {

	///////////////////////////////////////////////////////////////////////////////////
	// API
	constructor: function() {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
	},
	postCreate: function() {
		this._enableTooltip(this.messages.msgDurationValidation);

		if (this.selection)
			this._setValues(this.selection);

		var properties= Util.buildMap(this.presentation.properties);
		this._regexp= new RegExp(properties.regularExpression);
	},
	
	/* String[] */ getValues: function() {
		var selection= new Array();
		if (this._validateInput()) {
			var value= this._getValue();
			if (value)
				selection.push(value);
		}
		return selection;
	},

	_validateInput: function() {
		var value= this._getValue();
		if (value.length == 0)
			return true;
		return this._regexp.test(value);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_getValue: function() {
		return dojo.trim(this._textInput.value);
	},
	
	_setValues: function(/* UIItemDTO[] */ selection) {
		if (selection && selection.length > 0) {
			this._textInput.value= selection[0].label;
		}
	}
	
});
	
})();
